
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */





#include <stdio.h>


void checkspg(char filename[]) {

   FILE *infile;                        /* file pointer */
   int  i, j, k, l;                           /* looping var */
   int countvertex, countobject, countedge;
   int sumedge;
   double mvertex[3];

   infile = fopen(filename, "r");

   fscanf(infile, "%d", &countvertex);
   fscanf(infile, "%d", &countobject);
   fscanf(infile, "%d", &countedge);

   for (i=0; i<countvertex; i++)
      fscanf(infile, "%lf %lf %lf", &mvertex[0], &mvertex[1],
                                    &mvertex[2]);

   sumedge = 0;
   for (i=0; i<countobject; i++) {
      fscanf(infile, "%d", &j);

      if (j < 1) {
         printf("polygon %d: Null polygon...\n", i);
         fclose(infile);
         exit(1);
      }

      sumedge += j;

      for (k=0; k<j; k++) {
         fscanf(infile, "%d", &l);
         if (l < 1 || l > countvertex) {
            printf("polygon %d: Invalid vertex %d ...\n", i, k);
            fclose(infile);
            exit(1);
         }

      }

   }

   if (sumedge != countedge) 
      printf("Invalid edgecount (%d:%d)\n", countedge, sumedge);

   fclose(infile);
}



int main (int argc, char *argv[]) {

   if (argc < 2) {
      printf("usage: checkspg <infile>\n");
      exit(0);
   }

   checkspg(argv[1]);

   return 1;
}

