
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */

/* *************************************************************
************************************************************* */

#include "texture.h"
#include <time.h>
/* **************************************************
   main: program controller
************************************************** */
void main (int argc, char *argv[]) {

   texture      *tex;

   AOGLwindow	gwindow;
   int		WINX, WINY;
   XEvent mevent;
   int  i, j, k;
   unsigned int timer;
   int *maxx, *maxy;
   float fps;

   if (argc < 3) {
      printf("usage: flip frames/sec frame1 frame2 ...\n");
      exit(0);
   }

   j = argc-2;
   fps = atof(argv[1]);

   if (j<=0)
      exit(0);

   tex = new texture[j];
   for (i=0; i<j; i++)
      tex[i].read_texture(argv[i+2], 1);

   maxx = new int[j];
   maxy = new int[j];

   WINX = WINY = 0;

   for (i=0; i<j; i++) {
      k = tex[i].query_x();
      if (k > WINX)
         WINX = k;

      k = tex[i].query_y();
      if (k > WINY)
         WINY = k;
   }

   for (i=0; i<j; i++) {
      k = tex[i].query_x();

      if (WINX > k)
         maxx[i] = (WINX-k)>>1;
      else
         maxx[i] = 0;

      k = tex[i].query_y();

      if (WINY > k)
         maxy[i] = (WINY-k)>>1;
      else
         maxy[i] = 0;
   }

   gwindow.AOGLreset(argc, argv, WINX, WINY, "Flip");

   i=0;
   while(1) {
      timer = clock();

      glRasterPos2i(maxx[i], maxy[i]);
      glClear(GL_COLOR_BUFFER_BIT);
      gwindow.AOGLbitmap(&tex[i].tob);

      while(clock() >= timer && (clock()-timer)/(double)(CLOCKS_PER_SEC) < fps);
      i++;
      if (i==j) {
         i=0;

         XCheckMaskEvent (gwindow.mdisplay, KeyPressMask | ButtonPressMask, &mevent);
         if (mevent.type == KeyPress || mevent.type == ButtonPress)
            break;
      }

   }

   delete tex;
   delete maxx;
   delete maxy;

   gwindow.ALEXcancel();
}
