
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */

/* *************************************************************
************************************************************* */

#include "texture.h"
#include <time.h>
/* **************************************************
   main: program controller
************************************************** */
void main (int argc, char *argv[]) {

   texture      tex;

   AOGLwindow	gwindow;
   int		WINX, WINY;
   XEvent mevent;
   int  i, j;
   unsigned int timer;
   float fps;

   if (argc < 3) {
      printf("usage: mviewer frames/sec frame1 frame2 ...\n");
      exit(0);
   }

   j = argc-2;
   fps = atof(argv[1]);

   if (j<=0)
      exit(0);

   tex.read_texture(argv[2], 1);

   WINX = tex.query_x();
   WINY = tex.query_y();

   gwindow.AOGLreset(argc, argv, WINX, WINY, "Movie Viewer");

   i=0;
   while(1) {
      timer = clock();

      glClear(GL_COLOR_BUFFER_BIT);
      gwindow.AOGLbitmap(&tex.tob);

      i++;
      if (i==j) {
         i=0;

         XCheckMaskEvent (gwindow.mdisplay, KeyPressMask | ButtonPressMask, &mevent);
         if (mevent.type == KeyPress || mevent.type == ButtonPress)
            break;
      }

      tex.read_texture(argv[i+2], 1);

      while(clock() >= timer && (clock()-timer)/(double)(CLOCKS_PER_SEC) < fps);
   }

   gwindow.ALEXcancel();
}
