
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */

/* *************************************************************
************************************************************* */

#include "texture.h"
#include <time.h>
/* **************************************************
   main: program controller
************************************************** */
void main (int argc, char *argv[]) {

   rgb		tex;
   sfile	*file;

   AOGLwindow	gwindow;
   int		WINX, WINY;
   XEvent mevent;
   int  i, j;
   unsigned int timer;
   float fps;
   float zoom = 1;
   int start;

   if (argc < 3) {
      printf("usage: movie frames/sec <-z #> frame1 frame2 ...\n");
      exit(0);
   }

   if (argv[2][0] == '-' && (argv[2][1] == 'z')) {
      zoom = atof(argv[3]);
      j = argc - 4;
      start = 4;
   } 

   else {
      j = argc-2;
      start = 2;
   }

   fps = atof(argv[1]);

   if (j<=0)
      exit(0);

   file = new sfile[j];
   for (i=0; i<j; i++)
      file[i].scan_data(argv[start+i]);

   tex.scan_data(&file[0], 1);

   WINX = (int)(tex.query_x()*zoom);
   WINY = (int)(tex.query_y()*zoom);

   gwindow.AOGLreset(argc, argv, WINX, WINY, "RGB Movie");
   glPixelZoom(zoom, zoom);

   i=0;
   while(1) {
      timer = clock();

//      glClear(GL_COLOR_BUFFER_BIT);
      gwindow.AOGLbitmap(&tex);

      i++;
      if (i==j) {
         i=0;

         XCheckMaskEvent (gwindow.mdisplay, KeyPressMask | ButtonPressMask, &mevent);
         if (mevent.type == KeyPress || mevent.type == ButtonPress)
            break;
      }

      file[i].sseek(0);
      tex.scan_data(&file[i], 1);

      while(clock() >= timer && (clock()-timer)/(double)(CLOCKS_PER_SEC) < fps);
   }

   delete file;

   gwindow.ALEXcancel();
}
