
INC = -Itiff -Ijpeg

CC = CC
#CC = KCC

#	Macro to sacrifice accuracy/detail for speed
#GMACRO = -DREAL_FAST
GMACRO = 


CCFLAGS = $(ARCH) $(INC) $(GMACRO)


OBJ =        zbuffer.o eye.o light.o camera.o master.o slave.o \
             subslave.o texture.o texpoly.o io.o rgb.o map.o perlin.o \
             shader.o gif.o ppm.o matrix.o alex.o global.o base.o stuff.o \
             polyclet.o polyfile.o polyform.o polyshad.o \
             polyscan.o spatfile.o spatscan.o shadscan.o partscan.o radiant.o \
	     shadowpt.o geo.o sphere.o sbfast.o  sbrender.o sbbeam.o \
             collision.o laser.o texsbfast.o jpeg.o ilbm.o \
	     tiff.o cylinder.o cone.o line.o shadline.o

SRC =        zbuffer.c eye.c light.c camera.c master.c slave.c \
             subslave.c texture.c texpoly.c io.c rgb.c map.c perlin.c \
             shader.c gif.c ppm.c matrix.c alex.c global.c base.c stuff.c \
             polyclet.c polyfile.c polyform.c polyshad.c \
             polyscan.c spatfile.c spatscan.c shadscan.c partscan.c radiant.c \
	     shadowpt.c geo.c sphere.c sbfast.c sbrender.c sbbeam.c \
             collision.c laser.c texsbfast.c jpeg.c ilbm.c \
             tiff.c cylinder.c cone.c pixcon.c line.c shadline.c

JPGSRC =	jpeg/jcomapi.c jpeg/jdcoefct.c jpeg/jdinput.c jpeg/jdmerge.c jpeg/jdtrans.c jpeg/jidctint.c jpeg/jquant1.c \
		jpeg/jdapimin.c jpeg/jdcolor.c jpeg/jdmainct.c jpeg/jdphuff.c jpeg/jerror.c jpeg/jidctred.c jpeg/jquant2.c \
		jpeg/jdapistd.c jpeg/jddctmgr.c jpeg/jdmarker.c jpeg/jdpostct.c jpeg/jidctflt.c jpeg/jmemmgr.c jpeg/jutils.c \
		jpeg/jdatasrc.c jpeg/jdhuff.c jpeg/jdmaster.c jpeg/jdsample.c jpeg/jidctfst.c jpeg/jmemnobs.c

TIFFSRC = 	tiff/mkg3states.c tiff/tif_close.c tiff/tif_dumpmode.c tiff/tif_jpeg.c tiff/tif_print.c tiff/tif_unix.c \
		tiff/mkspans.c tiff/tif_compress.c tiff/tif_error.c tiff/tif_lzw.c tiff/tif_read.c tiff/tif_version.c \
		tiff/tif_apple.c tiff/tif_dir.c tiff/tif_fax3.c tiff/tif_msdos.c tiff/tif_strip.c tiff/tif_vms.c \
		tiff/tif_atari.c tiff/tif_dirinfo.c tiff/tif_fax4.c tiff/tif_next.c tiff/tif_swab.c tiff/tif_warning.c \
		tiff/tif_aux.c tiff/tif_dirread.c tiff/tif_flush.c tiff/tif_open.c tiff/tif_thunder.c tiff/tif_write.c \
		tiff/tif_ccittrle.c tiff/tif_dirwrite.c tiff/tif_getimage.c tiff/tif_packbits.c tiff/tif_tile.c

pixcon: libgraph.a pixcon.o
	$(CC) $(CCFLAGS) -o pixcon pixcon.o $(LIB)
	mv pixcon ../bin

laser.o: laser.h laser.c
	$(CC) -c $(CCFLAGS) laser.c

alex.o: alex.h map.h alex.c
	$(CC) -c $(CCFLAGS) alex.c

base.o: light.h camera.h eye.h matrix.h alex.h map.h global.h texture.h io.h \
	zbuffer.h shader.h texpoly.h texsbfast.h control.h base.h base.c
	$(CC) -c $(CCFLAGS) base.c

camera.o: alex.h map.h matrix.h camera.h eye.h global.h camera.c
	$(CC) -c $(CCFLAGS) camera.c

collision.o: matrix.h collision.c
	$(CC) -c $(CCFLAGS) collision.c

cone.o: alex.h global.h map.h zbuffer.h eye.h camera.h light.h base.h \
	   cone.h matrix.h control.h texpoly.h shader.h texture.h io.h \
	   polygon.h geo.h texsbfast.h cone.c
	$(CC) -c $(CCFLAGS) cone.c

cylinder.o: alex.h global.h map.h zbuffer.h eye.h camera.h light.h base.h \
	   cylinder.h matrix.h control.h texpoly.h shader.h texture.h io.h \
	   polygon.h geo.h texsbfast.h cylinder.c
	$(CC) -c $(CCFLAGS) cylinder.c

eye.o: matrix.h eye.h eye.c alex.h map.h
	$(CC) -c $(CCFLAGS) eye.c

geo.o: alex.h global.h map.h zbuffer.h eye.h camera.h light.h base.h \
	   sphere.h matrix.h control.h texpoly.h shader.h texture.h io.h \
	   polygon.h geo.h texsbfast.h geo.c
	$(CC) -c $(CCFLAGS) geo.c

gif.o: io.h texture.h map.h alex.h gif.c
	$(CC) -c $(CCFLAGS) gif.c

global.o: alex.h map.h global.c global.h
	$(CC) -c $(CCFLAGS) global.c

io.o: io.h io.c alex.h
	$(CC) -c $(CCFLAGS) io.c

jpeg.o: texture.h io.h map.h alex.h jpeg.c
	$(CC) -c $(CCFLAGS) jpeg.c

light.o: alex.h texture.h io.h global.h light.h matrix.h eye.h camera.h map.h light.c
	$(CC) -c $(CCFLAGS) light.c

line.o: alex.h global.h map.h zbuffer.h eye.h camera.h light.h base.h \
	line.h matrix.h control.h texpoly.h shader.h texture.h io.h \
	shadline.h texsbfast.h line.c
	$(CC) -c $(CCFLAGS) line.c

map.o:	map.h map.c
	$(CC) -c $(CCFLAGS) map.c

master.o: alex.h matrix.h texture.h io.h global.h eye.h light.h zbuffer.h base.h \
          map.h camera.h shader.h texpoly.h control.h texsbfast.h master.c
	$(CC) -c $(CCFLAGS) master.c

matrix.o: matrix.h matrix.c
	$(CC) -c $(CCFLAGS) matrix.c

partscan.o: alex.h global.h map.h zbuffer.h eye.h camera.h light.h base.h \
	    particle.h matrix.h control.h texpoly.h shader.h texture.h io.h \
	    shadowpt.h texsbfast.h partscan.c
	$(CC) -c $(CCFLAGS) partscan.c

perlin.o: matrix.h perlin.c
	$(CC) -c $(CCFLAGS) perlin.c

pixcon.o: global.h matrix.h light.h texture.h io.h alex.h map.h camera.h eye.h \
	  zbuffer.h shader.h texpoly.h control.h base.h \
	  shadow.h polygon.h radiant.h particle.h shadowpt.h spatch.h \
	  geo.h sphere.h cylinder.h cone.h sbfast.h pixcon.h laser.h texsbfast.h pixcon.c \
          line.h shadline.h pixcon.c
	$(CC) -c $(CCFLAGS) pixcon.c


polyclet.o: global.h matrix.h light.h texture.h io.h alex.h map.h camera.h eye.h \
	    zbuffer.h shader.h texpoly.h control.h base.h \
	    shadow.h polygon.h texsbfast.h polyclet.c
	$(CC) -c $(CCFLAGS) polyclet.c

polyfile.o:  global.h matrix.h light.h texture.h io.h alex.h map.h camera.h eye.h \
	    zbuffer.h shader.h texpoly.h control.h base.h \
	    shadow.h polygon.h texsbfast.h polyfile.c
	$(CC) -c $(CCFLAGS) polyfile.c

polyform.o: global.h matrix.h light.h texture.h io.h alex.h map.h camera.h eye.h \
	    zbuffer.h shader.h texpoly.h control.h base.h \
	    shadow.h polygon.h texsbfast.h polyform.c
	$(CC) -c $(CCFLAGS) polyform.c

polyscan.o: global.h matrix.h light.h texture.h io.h alex.h map.h camera.h eye.h \
	    zbuffer.h shader.h texpoly.h control.h base.h \
	    shadow.h polygon.h texsbfast.h polyscan.c
	$(CC) -c $(CCFLAGS) polyscan.c

polyshad.o: global.h matrix.h light.h texture.h io.h alex.h map.h camera.h eye.h \
	    zbuffer.h shader.h texpoly.h control.h base.h texsbfast.h \
	    shadow.h polygon.h polyshad.c polywfbw.c polybw.c polyct.c \
	    polygd.c polyal.c polypg.c polylt.c 
	$(CC) -c $(CCFLAGS) polyshad.c

ppm.o: io.h texture.h map.h alex.h ppm.c
	$(CC) -c $(CCFLAGS) ppm.c

radiant.o: alex.h global.h map.h zbuffer.h eye.h camera.h light.h base.h \
	   radiant.h matrix.h control.h texpoly.h shader.h texture.h io.h \
	   texsbfast.h radiant.c sphere.h geo.h polygon.h
	$(CC) -c $(CCFLAGS) radiant.c

rgb.o: io.h texture.h map.h alex.h rgb.c
	$(CC) -c $(CCFLAGS) rgb.c

sbfast.o: alex.h global.h map.h zbuffer.h eye.h camera.h light.h base.h \
	   sbfast.h matrix.h control.h texpoly.h shader.h texture.h io.h \
	   texsbfast.h sbfast.c
	$(CC) -c $(CCFLAGS) sbfast.c

sbbeam.o: alex.h global.h map.h zbuffer.h eye.h camera.h light.h base.h \
           sbfast.h matrix.h control.h texpoly.h shader.h texture.h io.h \
           sbbeam.c texsbfast.h sblt.c
	$(CC) -c $(CCFLAGS) sbbeam.c

sbrender.o: alex.h global.h map.h zbuffer.h eye.h camera.h light.h base.h \
           sbfast.h matrix.h control.h texpoly.h shader.h texture.h io.h \
           sbrender.c texsbfast.h sbshade.c
	$(CC) -c $(CCFLAGS) sbrender.c

shader.o: shader.h global.h matrix.h alex.h map.h shader.c
	$(CC) -c $(CCFLAGS) shader.c

shadline.o: alex.h global.h map.h zbuffer.h eye.h camera.h light.h base.h \
	    line.h matrix.h control.h texpoly.h shader.h texture.h io.h \
	    shadline.h texsbfast.h shadline.c
	$(CC) -c $(CCFLAGS) shadline.c

shadowpt.o: alex.h global.h map.h zbuffer.h eye.h camera.h light.h base.h \
	    particle.h matrix.h control.h texpoly.h shader.h texture.h io.h \
	    shadowpt.h texsbfast.h shadowpt.c
	$(CC) -c $(CCFLAGS) shadowpt.c

shadscan.o:  alex.h global.h map.h zbuffer.h eye.h camera.h light.h base.h \
	    polygon.h matrix.h control.h texpoly.h shader.h texture.h io.h \
	    shadow.h texsbfast.h shadscan.c
	$(CC) -c $(CCFLAGS) shadscan.c

slave.o: alex.h matrix.h texture.h io.h global.h eye.h light.h zbuffer.h base.h \
         map.h camera.h shader.h texpoly.h control.h texsbfast.h slave.c
	$(CC) -c $(CCFLAGS) slave.c

spatfile.o: global.h matrix.h light.h texture.h io.h alex.h map.h camera.h eye.h \
	    zbuffer.h shader.h texpoly.h control.h base.h \
	    shadow.h polygon.h spatch.h texsbfast.h spatfile.c
	$(CC) -c $(CCFLAGS) spatfile.c

spatscan.o: global.h matrix.h light.h texture.h io.h alex.h map.h camera.h eye.h \
	    zbuffer.h shader.h texpoly.h control.h base.h \
	    shadow.h polygon.h spatch.h texsbfast.h spatscan.c
	$(CC) -c $(CCFLAGS) spatscan.c

sphere.o: alex.h global.h map.h zbuffer.h eye.h camera.h light.h base.h \
	   sphere.h matrix.h control.h texpoly.h shader.h texture.h io.h \
	   polygon.h geo.h texsbfast.h radiant.h sphere.c
	$(CC) -c $(CCFLAGS) sphere.c

stuff.o: global.h matrix.h light.h texture.h io.h alex.h map.h camera.h eye.h \
         zbuffer.h shader.h texpoly.h control.h base.h \
         shadow.h polygon.h radiant.h particle.h shadowpt.h spatch.h \
         texsbfast.h sbfast.h pixcon.h geo.h sphere.h cylinder.h cone.h \
	 line.h shadline.h stuff.c
	$(CC) -c $(CCFLAGS) stuff.c

subslave.o: alex.h matrix.h texture.h io.h global.h eye.h light.h zbuffer.h base.h \
	    map.h camera.h shader.h texpoly.h control.h \
	    polygon.h radiant.h geo.h sphere.h cylinder.h cone.h sbfast.h \
	    texsbfast.h subslave.c
	$(CC) -c $(CCFLAGS) subslave.c

texpoly.o: alex.h global.h map.h texture.h io.h matrix.h texpoly.h texpoly.c
	$(CC) -c $(CCFLAGS) texpoly.c

texsbfast.o: alex.h global.h map.h texture.h io.h matrix.h texpoly.h \
		texsbfast.h texsbfast.c
	$(CC) -c $(CCFLAGS) texsbfast.c

texture.o: alex.h texture.h io.h map.h matrix.h global.h texture.c
	$(CC) -c $(CCFLAGS) texture.c

tiff.o: texture.h io.h map.h alex.h tiff.c
	$(CC) -c $(CCFLAGS) tiff.c

ilbm.o: io.h texture.h map.h alex.h ilbm.c
	$(CC) -c $(CCFLAGS) ilbm.c

zbuffer.o: global.h alex.h zbuffer.h map.h matrix.h zbuffer.c
	$(CC) -c $(CCFLAGS) zbuffer.c

libgraph.a: $(OBJ)
	ar r libgraph.a $(OBJ)
	mv libgraph.a ../lib

clean:
	rm -f $(OBJ)

