
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */





#if !defined (__CONE_H)
#define __CONE_H

#include "geo.h"


/* *************************************************************
************************************************************* */
class cone : public geo {

   protected:
      float length, radius[2];

      float calc_area();

      void transform(eye *parm);

      void pg(eye *parm, light *lparm, zbuffer *zbuff, int inc);
      void lt(light *lparm, int inc);
      void geo2poly(texpolygon **ptob, shaderlisttype *slist);

   public:

      cone() {
         length = radius[0] = radius[1] = 1;
      }

      rendertype query_whatami() { return CONE; }

      int parse(FILE *infile, char *token);

      int read_data(FILE *infile) { 
         fscanf(infile, "%f %f %f", &length, &radius[0], &radius[1]);
         length *= 0.5;

         return 1;
      }

};

#endif
