
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */





/* *************************************************************
   this file contains all functions to do transforms
************************************************************* */


#include "eye.h"

/* *************************************************************
   This procedure calculates the Nper matrix
************************************************************* */
void eye::nper() {

   float r[4][4];
   int i, j;

   init_mx(i, j, transform);

   transform[0][3] = -location[0];
   transform[1][3] = -location[1];
   transform[2][3] = -location[2];

   copyarray3(r[2], vpn);
   r[2][3] = 0;

   normalize3(r[2]);

   xproduct(r[0], vup, r[2]);
   r[0][3] = 0;

   normalize3(r[0]);

   xproduct(r[1], r[2], r[0]);
   r[1][3] = 0;

   normalize3(r[1]);

   r[3][0] = r[3][1] = r[3][2] = 0;
   r[3][3] = 1;

   matmatmulto(r, transform);

   inversemxrt(transform, Tinverse);            // inverse transformation
}


/* *************************************************************
   Scale image to the window
************************************************************* */
void eye::map2screen(float v[]) {

   v[0]  = mscale * (v[0]/(-v[2]) - vrc[0]);
   v[1]  = mscale * (v[1]/(-v[2]) - vrc[2]);
}


/* *************************************************************
   Scale image from the window
************************************************************* */
void eye::screen2map(float v[]) {

   v[1]     = (v[1]*imscale + vrc[2]) * (-v[2]);
   v[0]     = (v[0]*imscale + vrc[0]) * (-v[2]);
}


/* *************************************************************
        parallel project... (no div by z)
************************************************************* */
void eye::paramap2screen(float v[]) {

   v[0]  = mscale * (v[0] - vrc[0]);
   v[1]  = mscale * (v[1] - vrc[2]);
}


/* *************************************************************
   Scale image from the window
************************************************************* */
void eye::parascreen2map(float v[]) {

   v[1]     = (v[1]*imscale + vrc[2]);
   v[0]     = (v[0]*imscale + vrc[0]);
}

