
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */



#if !defined __EYE_H
#define __EYE_H

#include "matrix.h"
#include "alex.h"


/* *************************************************************
************************************************************* */


class eye {                            // camera data

   public:
      float location[3];               // camera point
      float vup[3];                    // vup
      float vrc[4];                    // vrc
      float mscale, imscale;           // used to size the viewport

      float vpn[3];                    // vpn

      float transform[4][4];
      float Tinverse[4][4];

      int   frame;

      void  nper();
      void  map2screen(float v[]);
      void  screen2map(float v[]);
      void  paramap2screen(float v[]);
      void  parascreen2map(float v[]);
      float query_scale() { return mscale; }

      eye() {
         float ffactor;

         ffactor = DEFWINX/(float)DEFWINY;
         location[0] = location[1] = location[2] = 0;
         vup[0] = vup[2] = 0;
         vup[1] = 1;
         vrc[0] = -ffactor;
         vrc[1] = ffactor;
         vrc[2] = -1;
         vrc[3] = 1;
         mscale = 1;
         vpn[0] = vpn[1] = 0;
         vpn[2] = -1;
         frame = 0;
      }

};

#endif
