
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */





#if !defined (__GEO_H)
#define __GEO_H

#include "polygon.h"


/* *************************************************************
************************************************************* */
class geo : public make_poly {

   protected:
      int row[2], col[2];
      float texcoord[4][2];
      texbase  *tob;
      vector4f wcenter;

      unsigned int query_texel(float tx, float ty, texcolortype *color, float d);
      int bound_box(eye *parm);

      virtual void pg(eye *parm, light *lparm, zbuffer *zbuff, int inc) = 0;
      virtual void lt(light *lparm, int inc) = 0;
      virtual void geo2poly(texpolygon **ptob, shaderlisttype *slist) = 0;

   public:

      void datacopy();

      int clip(eye *parm, int maxx, int maxy);
      int beamclip(light *parm, int maxx, int maxy);

      void colorize(grandchildtype *child);
      void beamscan(light *lparm, subslave grandchild[]);
      void scan(camera *cparm, light *lparm, zbuffer *zbuff, subslave grandchild[], pc **shadptr);
      void scan(camera *cparm, light *lparm, subslave grandchild[], pc **shadptr);

      int read_tex(char *filename, char *dfilename, texbase **tptr, texpolygon **tpptr);
      int read_3dtex(char *filename, char *dfilename, shader *sptr, shaderlisttype **slptr);

      int read_data(char filename[], datatype **dptr);
};

#endif
