
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */






/* *************************************************************
************************************************************* */

#include "line.h"


/* *************************************************************
************************************************************* */
int line::parse(FILE *infile, char *token) {

   switch (token[0]) {

      case 'p':
         if (!strcmp(token, "point")) {
            get_token(infile, token);
            center[0] = atof(token);
            get_token(infile, token);
            center[1] = atof(token);
            get_token(infile, token);
            center[2] = atof(token);

            get_token(infile, token);
            wwi[0] = atof(token);
            get_token(infile, token);
            wwi[1] = atof(token);
            get_token(infile, token);
            wwi[2] = atof(token);

            return 1;
         }

         break;

      case 's':		// before base
         if (!strcmp(token, "shade")) {
            get_token(infile, token);
            lower_case(token);

            switch (token[0]) {

               case 'w':
                  if (!strcmp(token, "wfbw")) {
                     mctype = WFBW;
                     return 1;
                  }

                  return 0;

               case 'g':
                  if (!strcmp(token, "gouraud")) {
                     mctype = GOURAUD;

                     get_token(infile, token);
                     color[0][0] = atof(token);
                     get_token(infile, token);
                     color[0][1] = atof(token);
                     get_token(infile, token);
                     color[0][2] = atof(token);

                     get_token(infile, token);
                     color[1][0] = atof(token);
                     get_token(infile, token);
                     color[1][1] = atof(token);
                     get_token(infile, token);
                     color[1][2] = atof(token);

                     return 1;
                  }

                  return 0;

               default:
                  break;
            }

            return 0;
         }

         break;

      default:
         break;
   }

   return pc::parse(infile, token);
}


/* *************************************************************
************************************************************* */
int line::read_data(char filename[], datatype **dptr) {

   return 0;
}

/* *************************************************************
************************************************************* */
int line::read_tex(char *filename, char *dfilename, texbase **tptr, texpolygon **tpptr) {

   return 0;
}


/* *************************************************************
************************************************************* */
int line::read_3dtex(char *filename, char *dfilename, shader *sptr, shaderlisttype **slptr) {

   return 0;
}


/* *************************************************************
   This function reads in the surface patch data
************************************************************* */
int line::read_data(FILE *infile) {

   fscanf(infile, "%f %f %f", &center[0], &center[1], &center[2]);

   if (mctype == GOURAUD)
      fscanf(infile, "%f %f %f", &color[0][0], &color[0][1], &color[0][2]);

   fscanf(infile, "%f %f %f", &wwi[0], &wwi[1], &wwi[2]);

   if (mctype == GOURAUD)
      fscanf(infile, "%f %f %f", &color[1][0], &color[1][1], &color[1][2]);

   return 0;
}


/* *************************************************************
************************************************************* */
int line::bound_box(eye *parm) {

   return 1;
}


/* *************************************************************
************************************************************* */
int line::lineclip(eye *parm) {

   int      i, j, k;                            // loop variables
   float    flat[2];
   float    d;

   copyarray3(bbox[0], wwai[0]);
   copyarray3(bbox[1], wwai[0]);

   for (i=0; i<3; i++)
      if (bbox[0][i] > wwai[1][i])
         bbox[0][i] = wwai[1][i];
      else
         if (bbox[1][i] < wwai[1][i])
            bbox[1][i] = wwai[1][i];

   if (bbox[1][2] < front &&                        // w/in boundaries
       -bbox[0][0]/bbox[1][2] >= parm->vrc[0] &&
       -bbox[1][0]/bbox[1][2] <= parm->vrc[1] &&
       -bbox[0][1]/bbox[1][2] >= parm->vrc[2] &&
       -bbox[1][1]/bbox[1][2] <= parm->vrc[3]) {
      return 1;
   }

   if (bbox[0][2] >= front ||                       // outside boundaries
       -bbox[0][0]/bbox[0][2] > parm->vrc[1] ||
       -bbox[1][0]/bbox[0][2] < parm->vrc[0] ||
       -bbox[0][1]/bbox[0][2] > parm->vrc[3] ||
       -bbox[1][1]/bbox[0][2] < parm->vrc[2]) {
      return 0;
   }

   for (i=0; i<2; i++) {
      k = (!i);

      if (wwai[i][2] > front) {
         d = (-wwai[i][2]) / (wwai[k][2] - wwai[i][2]);

         wwai[i][0] += d * (wwai[k][0] - wwai[i][0]);
         wwai[i][1] += d * (wwai[k][1] - wwai[i][1]);
         wwai[i][2] = front;

         if (mctype == GOURAUD) {
            wcolor[k][0] += d * (wcolor[k][0] - wcolor[i][0]);
            wcolor[k][1] += d * (wcolor[k][1] - wcolor[i][1]);
            wcolor[k][2] += d * (wcolor[k][2] - wcolor[i][2]);
         }

      }

      for (j=0; j<2; j++) {
         flat[0] = -wwai[i][j]/wwai[i][2];
         flat[1] = -wwai[k][j]/wwai[k][2];

         if (flat[0] > parm->vrc[1 + double(j)]) {
            d = (parm->vrc[1 + double(j)] - flat[0]) / (flat[1] - flat[0]);

            wwai[i][0] += d * (wwai[k][0] - wwai[i][0]);
            wwai[i][1] += d * (wwai[k][1] - wwai[i][1]);
            wwai[i][2] += d * (wwai[k][2] - wwai[i][2]);

            if (mctype == GOURAUD) {
               wcolor[k][0] += d * (wcolor[k][0] - wcolor[i][0]);
               wcolor[k][1] += d * (wcolor[k][1] - wcolor[i][1]);
               wcolor[k][2] += d * (wcolor[k][2] - wcolor[i][2]);
            }

         }

         else
            if (flat[0] < parm->vrc[double(j)]) {
               d = (parm->vrc[double(j)] - flat[0]) / (flat[1] - flat[0]);

               wwai[i][0] += d * (wwai[k][0] - wwai[i][0]);
               wwai[i][1] += d * (wwai[k][1] - wwai[i][1]);
               wwai[i][2] += d * (wwai[k][2] - wwai[i][2]);

               if (mctype == GOURAUD) {
                  wcolor[k][0] += d * (wcolor[k][0] - wcolor[i][0]);
                  wcolor[k][1] += d * (wcolor[k][1] - wcolor[i][1]);
                  wcolor[k][2] += d * (wcolor[k][2] - wcolor[i][2]);
               }

            }

      }

   }

   return 1;
}


/* *************************************************************
   This procedure puts the object in the edge table
************************************************************* */
void line::transform(eye *parm) {

   matvecmulto(parm->transform, wwai[0]);
   matvecmulto(parm->transform, wwai[1]);
}


/* **************************************************
************************************************** */
void line::colorize(grandchildtype *child) {

   int    i, j, k, l;
   int    scany;
   float  delta[2][3];
   float  pt[3];
   float  m;
   vector3f c, dc, hc;
   int flagtr = CITRANSPARENT & mcinfo;

   j = (wwai[0][1] <= wwai[1][1]);
   i = (!j);				// i is the smaller y

   switch (mctype) {

      case GOURAUD:

         m = 1.0/((wwai[j][1] - wwai[i][1]) + 1);
         delta[0][0] = (wwai[j][0] - wwai[i][0])*m;
         delta[0][1] = (wwai[j][2] - wwai[i][2])*m;

         dc[0] = (wcolor[j][0] - wcolor[i][0])*m;
         dc[1] = (wcolor[j][1] - wcolor[i][1])*m;
         dc[2] = (wcolor[j][2] - wcolor[i][2])*m;

         for (scany=round(wwai[i][1]); scany<=round(wwai[j][1]); scany++) {

            if (delta[0][0] > 0) {
               pt[0] = wwai[i][0];
               pt[1] = pt[0] + delta[0][0];
               pt[2] = wwai[i][2];

               copyarray3(c, wcolor[i]);
            }

            else {
               pt[1] = wwai[i][0];
               pt[0] = pt[1] + delta[0][0];
               pt[2] = wwai[i][2] + delta[0][1];

               c[0] = wcolor[i][0] + dc[0];
               c[1] = wcolor[i][1] + dc[1];
               c[2] = wcolor[i][2] + dc[2];
            }

            for (k=1; k<2; k++)
               delta[1][k] = delta[0][k]/delta[0][0];

            hc[0] = dc[0]/delta[0][0];
            hc[1] = dc[1]/delta[0][0];
            hc[2] = dc[2]/delta[0][0];

            k = round(pt[1]);

            for (l=round(pt[0]); l<=k; l++) {

               if (pt[2] > child->zbuff->zbuff[scany][l] || child->zbuff->zbuff[scany][l] > front) {
                  if (flagtr) {
                     if (child->zbuff->zbuff[scany][l] > front) {
                        child->zbuff->zbuff[scany][l] = -999999999;
                        child->zbuff->ybuff[scany][l][0] = child->zbuff->ybuff[scany][l][1] = child->zbuff->ybuff[scany][l][2] = 0;
                        copyarray3(child->zbuff->ambientbuff[scany][l], c);
                     }

                     else {
                        if (c[0] > child->zbuff->ambientbuff[scany][l][0])
                           child->zbuff->ambientbuff[scany][l][0] = c[0];
                        if (c[1] > child->zbuff->ambientbuff[scany][l][1])
                           child->zbuff->ambientbuff[scany][l][1] = c[1];
                        if (c[2] > child->zbuff->ambientbuff[scany][l][2])
                           child->zbuff->ambientbuff[scany][l][2] = c[2];
                     }

                  }

                  else {
                     child->zbuff->zbuff[scany][l] = pt[2];
                     child->zbuff->ybuff[scany][l][0] = child->zbuff->ybuff[scany][l][1] = child->zbuff->ybuff[scany][l][2] = 0;
                     copyarray3(child->zbuff->ambientbuff[scany][l], c);
                  }

               }

               pt[2] += delta[1][1];
               addarray3(c, hc);
            }

            wwai[i][0] += delta[0][0];
            wwai[i][2] += delta[0][1];
            addarray3(wcolor[i], dc);
         }

         break;

      default:  //case WFBW:

         m = (wwai[j][1] - wwai[i][1]) + 1;
         delta[0][0] = (wwai[j][0] - wwai[i][0])/m;
         delta[0][1] = (wwai[j][2] - wwai[i][2])/m;

         for (scany=round(wwai[i][1]); scany<=round(wwai[j][1]); scany++) {

            if (delta[0][0] > 0) {
               pt[0] = wwai[i][0];
               pt[1] = pt[0] + delta[0][0];
               pt[2] = wwai[i][2];

               delta[1][2] = delta[0][1]/delta[0][0];
            }

            else {
               pt[1] = wwai[i][0];
               pt[0] = pt[1] + delta[0][0];
               pt[2] = wwai[i][2] + delta[0][1];

               delta[1][2] = -delta[0][1]/delta[0][0];
            }

            k = round(pt[1]);

            for (l=round(pt[0]); l<=k; l++) {
               if (pt[2] > child->zbuff->zbuff[scany][l] || child->zbuff->zbuff[scany][l] > front) {
                  child->zbuff->zbuff[scany][l] = pt[2];
                  child->zbuff->ybuff[scany][l][0] = child->zbuff->ybuff[scany][l][1] = child->zbuff->ybuff[scany][l][2] = 0;
                  child->zbuff->ambientbuff[scany][l][0] = child->zbuff->ambientbuff[scany][l][1] = child->zbuff->ambientbuff[scany][l][2] = 1;
               }

               pt[2] += delta[1][2];
            }

            wwai[i][0]   += delta[0][0];
            wwai[i][2]   += delta[0][1];
         }

         break;
   }

   child->done = 1;
}


/* *************************************************************
************************************************************* */
void line::datacopy() {

   copyarray3(wwai[0], center);
   wwai[0][3] = 1;

   copyarray3(wwai[1], wwi);
   wwai[1][3] = 1;

   if (mctype == GOURAUD) {
      copyarray3(wcolor[0], color[0]);
      copyarray3(wcolor[1], color[1]);
   }

}


/* **************************************************
************************************************** */
void line::scan(camera *cparm, light *lparm, zbuffer *zbuff, subslave grandchild[], pc **shadptr) {

   shadline *str;
   grandchildtype offspring;
   light *lmain;

   for (lmain=lparm; lmain!=(light *)NULL && lparm->ltype!=POINT && lparm->ltype!=FAR; lmain=lmain->next);

   if (sflag && lmain!=(light *)NULL && !NOSHADOW && !(mcinfo & CITRANSPARENT)) {
      str = new shadline;
      str->begin_scan();
      if (str->datacopy2(this, lmain)) {
         str->next = *shadptr;
         *shadptr = str;
      }

      else {
         str->end_scan();
         delete str;
      }

   }

   transform(cparm);         // transform objects

   if (!lineclip(cparm))
      return;

   cparm->map2screen(wwai[0]);
   cparm->map2screen(wwai[1]);

   offspring.zbuff  = zbuff;
   offspring.done   = 0;

   colorize(&offspring);
}


/* **************************************************
************************************************** */
void line::scan(camera *cparm, light *lparm, subslave grandchild[], pc **shadptr) {

   int    pt[2][2];
   shadline *str;
   light *lmain;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype!=POINT && lmain->ltype!=FAR; lmain=lmain->next);

   if (sflag && lmain!=(light *)NULL && !NOSHADOW && !(mcinfo & CITRANSPARENT)) {
      str = new shadline;
      str->begin_scan();
      if (str->datacopy2(this, lmain)) {
         str->next = *shadptr;
         *shadptr = str;
      }

      else {
         str->end_scan();
         delete str;
      }

   }

   transform(cparm);         // transform objects

   if (!lineclip(cparm)) 
      return;

   cparm->map2screen(wwai[0]);
   cparm->map2screen(wwai[1]);

   pt[0][0] = round(wwai[0][0]);
   pt[0][1] = round(wwai[0][1]);

   glColor3f(1.0, 1.0, 1.0);

   pt[1][0] = round(wwai[1][0]);
   pt[1][1] = round(wwai[1][1]);

   glBegin(GL_LINES);
      glVertex2iv(pt[0]);
      glVertex2iv(pt[1]);
   glEnd();
}


/* **************************************************
************************************************** */
void line::beamscan(light *lparm, subslave grandchild[]) {

   int   i, j, k, l;
   int    scany;
   float  delta[2][6];
   float  pt[6];
   float  m;

   transform(lparm);         // transform objects

   if (!lineclip(lparm))
      return;

   lparm->map2screen(wwai[0]);
   lparm->map2screen(wwai[1]);

   j = (wwai[0][1] <= wwai[1][1]);
   i = (!j);

   m = (wwai[j][1] - wwai[i][1]) + 1;
   delta[0][0] = (wwai[j][0] - wwai[i][0])/m;
   delta[0][1] = (wwai[j][2] - wwai[i][2])/m;

   for (scany=round(wwai[i][1]); scany<=round(wwai[j][1]); scany++) {

      if (delta[0][0] > 0) {
         pt[0] = wwai[i][0];
         pt[1] = pt[0] + delta[0][0];
         pt[2] = wwai[i][2];

         delta[1][2] = delta[0][1]/delta[0][0];
      }

      else {
         pt[1] = wwai[i][0];
         pt[0] = pt[1] + delta[0][0];
         pt[2] = wwai[i][2] + delta[0][1];

         delta[1][2] = -delta[0][1]/delta[0][0];
      }

      k = round(pt[1]);

      for (l=round(pt[0]); l<=k; l++) {
         if (pt[2] > lparm->lbuff.lbuff->zbuff.pdata[scany][l] || lparm->lbuff.lbuff->zbuff.pdata[scany][l] > front) {
            lparm->lbuff.lbuff->zbuff.pdata[scany][l] = pt[2];
            lparm->lbuff.lbuff->idbuff.pdata[scany][l] = id;
         }

         pt[2] += delta[1][2];
      }

      wwai[i][0]   += delta[0][0];
      wwai[i][2]   += delta[0][1];
   }

}

