
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */

#if !defined __LINE_H
#define __LINE_H

#include "base.h"

class shadline;

/* *************************************************************
************************************************************* */
class line : public pc {

   friend class shadline;

   protected:
      float wwi[3];
      float color[2][3];

      float wwai[2][4];
      float wcolor[2][3];

      int  lineclip(eye *parm);

      void transform(eye *parm);
      int  bound_box(eye *parm);

   public:

      line() {
         copyarray3(wwi, center);
         color[0][0] = color[0][1] = color[0][2] =
         color[1][0] = color[1][1] = color[1][2] = 1.0;
      }

      rendertype query_whatami() { return LINE; }

      void datacopy();

      void scan(camera *cparm, light *lparm, zbuffer *zbuff, subslave grandchild[], pc **shadptr);
      void scan(camera *cparm, light *lparm, subslave grandchild[], pc **shadptr);

      void beamscan(light *lparm, subslave grandchild[]);

      int parse(FILE *infile, char *token);

      int read_data(FILE *infile);
      int read_data(char filename[], datatype **dptr);

      int read_tex(char *filename, char *dfilename, texbase **tptr, texpolygon **tpptr);
      int read_3dtex(char *filename, char *dfilename, shader *sptr, shaderlisttype **slptr);

      void colorize(grandchildtype *child);
};

#include "shadline.h"

#endif
