
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */

#if !defined __PARTICLE_H
#define __PARTICLE_H

#include "base.h"

class shadowpt;

/* *************************************************************
************************************************************* */
class particle : public pc {

   friend class shadowpt;

   protected:
      vector3f color;

      vector4f wwai;
      vector3f wcolor;

      int  partclip(eye *parm);

      void transform(eye *parm);
      int  bound_box(eye *parm);

   public:
      particle() {
         color[0] = color[1] = color[2] = 1.0;
      }

      rendertype query_whatami() { return PARTICLE; }

      void datacopy();

      void scan(camera *cparm, light *lparm, zbuffer *zbuff, subslave grandchild[], pc **shadptr);
      void scan(camera *cparm, light *lparm, subslave grandchild[], pc **shadptr);

      void beamscan(light *lparm, subslave grandchild[]);

      int parse(FILE *infile, char *token);

      int read_data(FILE *infile);
      int read_data(char filename[], datatype **dptr);

      int read_tex(char *filename, char *dfilename, texbase **tptr, texpolygon **tpptr);
      int read_3dtex(char *filename, char *dfilename, shader *sptr, shaderlisttype **slptr);

      void colorize(grandchildtype *child);
};

#include "shadowpt.h"

#endif
