
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */






/* *************************************************************
************************************************************* */

#include "particle.h"


/* *************************************************************
************************************************************* */
int particle::parse(FILE *infile, char *token) {

   switch (token[0]) {

      case 't':
         if (!strcmp(token, "location")) {
            get_token(infile, token);
            center[0] = atof(token);
            get_token(infile, token);
            center[1] = atof(token);
            get_token(infile, token);
            center[2] = atof(token);

            return 1;
         }

         break;

      case 's':		// before base
         if (!strcmp(token, "shade")) {
            get_token(infile, token);
            lower_case(token);

            switch (token[0]) {

               case 'w':
                  if (!strcmp(token, "wfbw")) {
                     mctype = WFBW;
                     return 1;
                  }

                  return 0;

               case 'g':
                  if (!strcmp(token, "gouraud")) {
                     mctype = GOURAUD;

                     get_token(infile, token);
                     color[0] = atof(token);
                     get_token(infile, token);
                     color[1] = atof(token);
                     get_token(infile, token);
                     color[2] = atof(token);
                     return 1;
                  }

                  return 0;

               default:
                  return 0;
            }

            return 0;
         }

         break;

      default:
         break;
   }

   return pc::parse(infile, token);
}


/* *************************************************************
************************************************************* */
int particle::read_data(char filename[], datatype **dptr) {

   return 0;
}

/* *************************************************************
************************************************************* */
int particle::read_tex(char *filename, char *dfilename, texbase **tptr, texpolygon **tpptr) {

   return 0;
}


/* *************************************************************
************************************************************* */
int particle::read_3dtex(char *filename, char *dfilename, shader *sptr, shaderlisttype **slptr) {

   return 0;
}


/* *************************************************************
   This function reads in the surface patch data
************************************************************* */
int particle::read_data(FILE *infile) {

   fscanf(infile, "%f %f %f", &center[0], &center[1], &center[2]);

   if (mctype == WFBW)
      return 0;

   fscanf(infile, "%f %f %f", &color[0], &color[1], &color[2]);

   return 0;
}


/* *************************************************************
************************************************************* */
int particle::bound_box(eye *parm) {

   return 1;
}


/* *************************************************************
   this is the basic particle clipper
************************************************************* */
int particle::partclip(eye *parm) {

   float    flat[2];

   copyarray3(bbox[0], wwai);
   copyarray3(bbox[1], wwai);

   flat[0] = -bbox[0][0]/bbox[1][2];
   flat[1] = -bbox[0][1]/bbox[1][2];

   if (bbox[1][2] < front &&                     // w/in boundaries
       flat[0] >= parm->vrc[0] && flat[0] <= parm->vrc[1] &&
       flat[1] >= parm->vrc[2] && flat[1] <= parm->vrc[3]) {

      return 1;
   }

   return 0;
}


/* *************************************************************
   This procedure puts the object in the edge table
************************************************************* */
void particle::transform(eye *parm) {

   matvecmulto(parm->transform, wwai);
}


/* **************************************************
************************************************** */
void particle::colorize(grandchildtype *child) {

   int    i, j;

   j = round(wwai[0]);
   i = round(wwai[1]);

   if (wwai[2] > child->zbuff->zbuff[i][j] || child->zbuff->zbuff[i][j] > front) {

      if (mctype == GOURAUD) {
         if (mcinfo & CITRANSPARENT) {
            if (child->zbuff->zbuff[i][j] > front) {
               child->zbuff->zbuff[i][j] = -999999999;
               child->zbuff->ybuff[i][j][0] = child->zbuff->ybuff[i][j][1] = child->zbuff->ybuff[i][j][2] = 0;
               copyarray3(child->zbuff->ambientbuff[i][j], wcolor);
            }

            else {
               if (wcolor[0] > child->zbuff->ambientbuff[i][j][0])
                  child->zbuff->ambientbuff[i][j][0] = wcolor[0];
               if (wcolor[1] > child->zbuff->ambientbuff[i][j][1])
                  child->zbuff->ambientbuff[i][j][1] = wcolor[1];
               if (wcolor[2] > child->zbuff->ambientbuff[i][j][2])
                  child->zbuff->ambientbuff[i][j][2] = wcolor[2];
            }

         }

         else {
            child->zbuff->zbuff[i][j] = wwai[2];
            child->zbuff->ybuff[i][j][0] = child->zbuff->ybuff[i][j][1] = child->zbuff->ybuff[i][j][2] = 0;
            copyarray3(child->zbuff->ambientbuff[i][j], wcolor);
         }

      }

      else {
         child->zbuff->zbuff[i][j] = wwai[2];
         child->zbuff->ybuff[i][j][0] = child->zbuff->ybuff[i][j][1] = child->zbuff->ybuff[i][j][2] = 0;
         child->zbuff->ambientbuff[i][j][0] = child->zbuff->ambientbuff[i][j][1] = child->zbuff->ambientbuff[i][j][2] = 1;
      }

   }

   child->done = 1;
}


/* *************************************************************
************************************************************* */
void particle::datacopy() {

   copyarray3(wwai, center);
   wwai[3] = 1;

   copyarray3(wcolor, color);
}


/* **************************************************
************************************************** */
void particle::scan(camera *cparm, light *lparm, zbuffer *zbuff, subslave grandchild[], pc **shadptr) {

   shadowpt *str;
   grandchildtype offspring;
   light *lmain;

   for (lmain=lparm; lmain!=(light *)NULL && lparm->ltype!=POINT && lparm->ltype!=FAR; lmain=lmain->next);

   if (sflag && lmain!=(light *)NULL && !NOSHADOW && !(mcinfo & CITRANSPARENT)) {
      str = new shadowpt;
      str->begin_scan();
      if (str->datacopy2(this, lmain)) {
         str->next = *shadptr;
         *shadptr = str;
      }

      else {
         str->end_scan();
         delete str;
      }

   }

   transform(cparm);         // transform objects

   if (!partclip(cparm))
      return;

   cparm->map2screen(wwai);

   offspring.zbuff  = zbuff;
   offspring.done   = 0;

   colorize(&offspring);
}


/* **************************************************
************************************************** */
void particle::scan(camera *cparm, light *lparm, subslave grandchild[], pc **shadptr) {

   int    pt[2];
   shadowpt *str;
   light *lmain;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype!=POINT && lmain->ltype!=FAR; lmain=lmain->next);

   if (sflag && lmain!=(light *)NULL && !NOSHADOW && !(mcinfo & CITRANSPARENT)) {
      str = new shadowpt;
      str->begin_scan();
      if (str->datacopy2(this, lmain)) {
         str->next = *shadptr;
         *shadptr = str;
      }

      else {
         str->end_scan();
         delete str;
      }

   }

   transform(cparm);         // transform objects

   if (!partclip(cparm))
      return;

   cparm->map2screen(wwai);

   pt[0] = round(wwai[0]);
   pt[1] = round(wwai[1]);

   glColor3f(1.0, 1.0, 1.0);

   glBegin(GL_POINTS);
      glVertex2iv(pt);
   glEnd();
}


/* **************************************************
************************************************** */
void particle::beamscan(light *lparm, subslave grandchild[]) {

   int   i, j;

   transform(lparm);         // transform objects

   if (!partclip(lparm))
      return;

   lparm->map2screen(wwai);

   j = round(wwai[0]);
   i = round(wwai[1]);

   if (wwai[2] > lparm->lbuff.lbuff->zbuff.pdata[i][j] || lparm->lbuff.lbuff->zbuff.pdata[i][j] > front) {
      lparm->lbuff.lbuff->zbuff.pdata[i][j] = wwai[2];
      lparm->lbuff.lbuff->idbuff.pdata[i][j] = id;
   }

}

