
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */





/* *************************************************************
   This file creates the edge table
************************************************************* */


#include <bstring.h>
#include "polygon.h"

/* *************************************************************
************************************************************* */
void polygon::post_clip(edgetype *ptr) {

   edgetype *qtr, *rtr;

   if (ptr->next == (edgetype *)NULL)
      return;

   qtr = ptr->next;
   while (qtr->next != (edgetype *)NULL)

      if (nte_vector3(qtr->pt2, qtr->next->pt1))
         if (nre_vector3(qtr->pt2, qtr->next->pt1)) {
            rtr = qtr->next;
            copyarray3(qtr->pt2, rtr->pt1);
            copyarray3(qtr->delta, rtr->colorstuff1);

            if (ptflag[qtr->color])
               copyarray2(qtr->t[1], rtr->t[0]);

            qtr = rtr;
         }

         else {
            rtr = new edgetype;
            rtr->color = qtr->color;

            copyarray3(rtr->pt1, qtr->pt2);
            copyarray3(rtr->colorstuff1,  qtr->delta);
            copyarray3(rtr->pt2, qtr->next->pt1);
            copyarray3(rtr->delta, qtr->next->colorstuff1);

            if (ptflag[rtr->color]) {
               copyarray2(rtr->t[0], qtr->t[1]);
               copyarray2(rtr->t[1], qtr->next->t[0]);
            }

            rtr->next = qtr->next;
            qtr->next = rtr;
            qtr = rtr->next;
         }

      else
         qtr = qtr->next;

   if (ptr->next == qtr) {
      delete qtr;
      ptr->next = (edgetype *)NULL;
   }

   else
      if (nte_vector3(qtr->pt2, ptr->next->pt1))
         if (nre_vector3(qtr->pt2, ptr->next->pt1)) {
            rtr = ptr->next;
            copyarray3(qtr->pt2, rtr->pt1);
            copyarray3(qtr->delta, rtr->colorstuff1);

            if (ptflag[qtr->color])
               copyarray2(qtr->t[1], rtr->t[0]);
         }

      else {
         rtr = new edgetype;
         rtr->color = qtr->color;

         copyarray3(rtr->pt1, qtr->pt2);
         copyarray3(rtr->colorstuff1,  qtr->delta);
         copyarray3(rtr->pt2, ptr->next->pt1);
         copyarray3(rtr->delta,  ptr->next->colorstuff1);

         if (ptflag[rtr->color]) {
            copyarray2(rtr->t[0], qtr->t[1]);
            copyarray2(rtr->t[1], ptr->next->t[0]);
         }
 
         rtr->next = qtr->next;
         qtr->next = rtr;
      }

}


/* *************************************************************
************************************************************* */
void polygon::clip_greater(edgetype *ptr, int i, float plane, float *normal, eye *parm) {

   vector3f d, n;
   float  factor;
   float  bound;
   int    j;
   edgetype *qtr, *rtr;

   if (ptr->next == (edgetype *)NULL)
      return;

   bound = plane + CORRECT;

   qtr = ptr;
   while (qtr->next != (edgetype *)NULL) {

      if (qtr->next->pt1[i] > bound)
         if (qtr->next->pt2[i] > bound) {
            rtr = qtr->next;
            qtr->next = rtr->next;
            delete rtr;
         }

         else {
            qtr = qtr->next;
            for (j=0; j<3; j++) {
               d[j] = qtr->pt2[j] - qtr->pt1[j];
               n[j] = qtr->delta[j] - qtr->colorstuff1[j];
            }

            factor = (plane-qtr->pt1[i])/d[i];

            for (j=0; j<3; j++) {
               qtr->pt1[j] += factor*d[j];
               qtr->colorstuff1[j] += factor*n[j];
            }

            if (ptflag[qtr->color]) {
               qtr->t[0][0] += factor*(qtr->t[1][0]-qtr->t[0][0]);
               qtr->t[0][1] += factor*(qtr->t[1][1]-qtr->t[0][1]);
            }

            if (i != Z && mctype > WFBW)
               qtr->pt1[2] = engine(normal, qtr->pt1, parm);
         }

      else {
         qtr = qtr->next;

         if (qtr->pt2[i] > bound) {
            for (j=0; j<3; j++) {
               d[j] = qtr->pt1[j] - qtr->pt2[j];
               n[j] = qtr->colorstuff1[j] - qtr->delta[j];
            }

            factor = (plane-qtr->pt2[i])/d[i];

            for (j=0; j<3; j++) {
               qtr->pt2[j] += factor*d[j];
               qtr->delta[j]  += factor*n[j];
            }

            if (ptflag[qtr->color]) {
               qtr->t[1][0]  += factor*(qtr->t[0][0]-qtr->t[1][0]);
               qtr->t[1][1]  += factor*(qtr->t[0][1]-qtr->t[1][1]);
            }

            if (i != Z && mctype > WFBW)
               qtr->pt2[2] = engine(normal, qtr->pt2, parm);
         }

      }

   }

}


/* *************************************************************
************************************************************* */
void polygon::clip_lesser(edgetype *ptr, int i, float plane, float *normal, eye *parm) {

   vector3f d, n;
   float  factor;
   float  bound;
   int    j;
   edgetype *qtr, *rtr;

   if (ptr->next == (edgetype *)NULL)
      return;

   bound = plane - CORRECT;

   qtr = ptr;
   while (qtr->next != (edgetype *)NULL) {

      if (qtr->next->pt1[i] < bound)
         if (qtr->next->pt2[i] < bound) {
            rtr = qtr->next;
            qtr->next = rtr->next;
            delete rtr;
         }

         else {
            qtr = qtr->next;
            for (j=0; j<3; j++) {
               d[j] = qtr->pt2[j] - qtr->pt1[j];
               n[j] = qtr->delta[j] - qtr->colorstuff1[j];
            }

            factor = (plane-qtr->pt1[i])/d[i];

            for (j=0; j<3; j++) {
               qtr->pt1[j] += factor*d[j];
               qtr->colorstuff1[j]  += factor*n[j];
            }

            if (ptflag[qtr->color]) {
               qtr->t[0][0] += factor*(qtr->t[1][0]-qtr->t[0][0]);
               qtr->t[0][1] += factor*(qtr->t[1][1]-qtr->t[0][1]);
            }

            if (i != Z && mctype > WFBW)
               qtr->pt1[2] = engine(normal, qtr->pt1, parm);
         }

      else {
         qtr = qtr->next;

         if (qtr->pt2[i] < bound) {
            for (j=0; j<3; j++) {
               d[j] = qtr->pt1[j] - qtr->pt2[j];
               n[j] = qtr->colorstuff1[j] - qtr->delta[j];
            }

            factor = (plane-qtr->pt2[i])/d[i];

            for (j=0; j<3; j++) {
               qtr->pt2[j] += factor*d[j];
               qtr->delta[j]  += factor*n[j];
            }

            if (ptflag[qtr->color]) {
               qtr->t[1][0]  += factor*(qtr->t[0][0]-qtr->t[1][0]);
               qtr->t[1][1]  += factor*(qtr->t[0][1]-qtr->t[1][1]);
            }

            if (i != Z && mctype > WFBW)
               qtr->pt2[2] = engine(normal, qtr->pt2, parm);
         }

      }

   }

}


/* *************************************************************
************************************************************* */
void polygon::bfclip_greater(edgetype *ptr, int i, float plane, float *normal, eye *parm) {

   vector3f d, n;
   float  factor;
   float  bound;
   int    j;
   edgetype *qtr, *rtr;

   if (ptr->next == (edgetype *)NULL)
      return;

   bound = plane + CORRECT;

   qtr = ptr;
   while (qtr->next != (edgetype *)NULL) {

      if (qtr->next->pt1[i] > bound)
         if (qtr->next->pt2[i] > bound) {
            rtr = qtr->next;
            qtr->next = rtr->next;
            delete rtr;
         }

         else {
            qtr = qtr->next;
            for (j=0; j<3; j++) {
               d[j] = qtr->pt2[j] - qtr->pt1[j];
               n[j] = qtr->delta[j] - qtr->colorstuff1[j];
            }

            factor = (plane-qtr->pt1[i])/d[i];

            for (j=0; j<3; j++) {
               qtr->pt1[j] += factor*d[j];
               qtr->colorstuff1[j]  += factor*n[j];
            }

            if (i != Z && mctype > WFBW)
               qtr->pt1[2] = bfengine(normal, qtr->pt1, parm);
         }

      else {
         qtr = qtr->next;

         if (qtr->pt2[i] > bound) {
            for (j=0; j<3; j++) {
               d[j] = qtr->pt1[j] - qtr->pt2[j];
               n[j] = qtr->colorstuff1[j] - qtr->delta[j];
            }

            factor = (plane-qtr->pt2[i])/d[i];

            for (j=0; j<3; j++) {
               qtr->pt2[j] += factor*d[j];
               qtr->delta[j]  += factor*n[j];
            }

            if (i != Z && mctype > WFBW)
               qtr->pt2[2] = bfengine(normal, qtr->pt2, parm);
         }

      }

   }

}


/* *************************************************************
************************************************************* */
void polygon::bfclip_lesser(edgetype *ptr, int i, float plane, float *normal, eye *parm) {

   vector3f d, n;
   float  factor;
   float  bound;
   int    j;
   edgetype *qtr, *rtr;

   if (ptr->next == (edgetype *)NULL)
      return;

   bound = plane - CORRECT;

   qtr = ptr;
   while (qtr->next != (edgetype *)NULL) {

      if (qtr->next->pt1[i] < bound)
         if (qtr->next->pt2[i] < bound) {
            rtr = qtr->next;
            qtr->next = rtr->next;
            delete rtr;
         }

         else {
            qtr = qtr->next;
            for (j=0; j<3; j++) {
               d[j] = qtr->pt2[j] - qtr->pt1[j];
               n[j] = qtr->delta[j] - qtr->colorstuff1[j];
            }

            factor = (plane-qtr->pt1[i])/d[i];

            for (j=0; j<3; j++) {
               qtr->pt1[j] += factor*d[j];
               qtr->colorstuff1[j]  += factor*n[j];
            }

            if (i != Z && mctype > WFBW)
               qtr->pt1[2] = bfengine(normal, qtr->pt1, parm);
         }

      else {
         qtr = qtr->next;

         if (qtr->pt2[i] < bound) {
            for (j=0; j<3; j++) {
               d[j] = qtr->pt1[j] - qtr->pt2[j];
               n[j] = qtr->colorstuff1[j] - qtr->delta[j];
            }

            factor = (plane-qtr->pt2[i])/d[i];

            for (j=0; j<3; j++) {
               qtr->pt2[j] += factor*d[j];
               qtr->delta[j]  += factor*n[j];
            }

            if (i != Z && mctype > WFBW)
               qtr->pt2[2] = bfengine(normal, qtr->pt2, parm);
         }

      }

   }

}


/* *************************************************************
   this function initiates an edge in the edge table
************************************************************* */
int polygon::prepare_edge(int polynum, edgetype *ptr, eye *parm, light *lparm) {

   vector3f temp, surface;
   int      i;
   float    deltay;

   deltay = 1.0/ (ptr->pt2[1] - ptr->pt1[1]);

   ptr->deltax  = (ptr->pt2[0] - ptr->pt1[0]) * deltay;
   ptr->dx = ptr->deltax * MAXSUBPROC;
   ptr->deltaz  = (ptr->pt2[2] - ptr->pt1[2]) * deltay;
   ptr->dz = ptr->deltaz * MAXSUBPROC;

   switch (mctype) {
      case PHONG:                                       // phong
         ptr->delta[0] = (ptr->delta[0] - ptr->colorstuff1[0]) * deltay;
         ptr->d[0] = ptr->delta[0] * MAXSUBPROC;
         ptr->delta[1] = (ptr->delta[1] - ptr->colorstuff1[1]) * deltay;
         ptr->d[1] = ptr->delta[1] * MAXSUBPROC;
         ptr->delta[2] = (ptr->delta[2] - ptr->colorstuff1[2]) * deltay;
         ptr->d[2] = ptr->delta[2] * MAXSUBPROC;

         break;

      case GOURAUD:
         if (lparm != (light *)NULL) {

            copyarray3(temp, ptr->colorstuff1);
            copyarray3(ptr->colorstuff1, ob->shade[polynum].ambient);
            copyarray3(surface, ptr->pt1);
            parm->screen2map(surface);
            lparm->intensity(surface, temp, ptr->colorstuff1, parm, ob->shade[polynum].color, id);

            copyarray3(temp, ptr->delta);
            copyarray3(ptr->delta, ob->shade[polynum].ambient);
            copyarray3(surface, ptr->pt2);
            parm->screen2map(surface);
            lparm->intensity(surface, temp, ptr->delta, parm, ob->shade[polynum].color, id);

            ptr->delta[0] = (ptr->delta[0] - ptr->colorstuff1[0]) * deltay;
            ptr->d[0] = ptr->delta[0] * MAXSUBPROC;
            ptr->delta[1] = (ptr->delta[1] - ptr->colorstuff1[1]) * deltay;
            ptr->d[1] = ptr->delta[1] * MAXSUBPROC;
            ptr->delta[2] = (ptr->delta[2] - ptr->colorstuff1[2]) * deltay;
            ptr->d[2] = ptr->delta[2] * MAXSUBPROC;
         }

         else {
            ptr->colorstuff1[0] = ptr->colorstuff1[1] = ptr->colorstuff1[2] = 0;
            ptr->delta[0] = ptr->delta[1] = ptr->delta[2] = 0;
            ptr->d[0] = ptr->d[1] = ptr->d[2] = 0;
         }

         break;

      default:
         break;
   }

   if (ptflag[ptr->color]) {
       ptr->deltat[0] = (ptr->t[1][0] - ptr->t[0][0]) * deltay;
       ptr->dt[0] = ptr->deltat[0] * MAXSUBPROC;
       ptr->deltat[1] = (ptr->t[1][1] - ptr->t[0][1]) * deltay;
       ptr->dt[1] = ptr->deltat[1] * MAXSUBPROC;
   }

   ptr->pt1[1] = (float )(i = round(ptr->pt1[1]));

   return i;
}


/* *************************************************************
   this function inserts an edge in the edge table
************************************************************* */
void polygon::insert_edge(edgetype *ptr, bindex **btr, bindex **freelist) {

   edgetype *qtr;
   bindex   *pbtr;

   if (*btr == (bindex *)NULL) {
      if (*freelist == (bindex *)NULL)
         pbtr = new bindex;
      else {
         pbtr = *freelist;
         *freelist = pbtr->next;
         pbtr->next = (bindex *)NULL;
      }

      pbtr->id = ptr->color;
      *btr = pbtr;
   }

   else {
      pbtr = (*btr)->find(ptr->color);

      if (pbtr == (bindex *)NULL) {
         if (*freelist == (bindex *)NULL)
            pbtr = new bindex;
         else {
            pbtr = *freelist;
            *freelist = pbtr->next;
            pbtr->next = (bindex *)NULL;
         }

         pbtr->id = ptr->color;
         (*btr)->insert(pbtr);
      }

   }

   if (pbtr->bucket == (edgetype *)NULL) {
      pbtr->bucket = pbtr->ebucket = ptr;
      return;
   }

   if (ptr->pt1[0] >= pbtr->ebucket->pt1[0]) {
      pbtr->ebucket = (pbtr->ebucket->next = ptr);
      ptr->next = (edgetype *)NULL;
      return;
   }

   if (ptr->pt1[0] <= pbtr->bucket->pt1[0]) {
      ptr->next = pbtr->bucket;
      pbtr->bucket = ptr;
      return;
   }

   qtr = pbtr->bucket;

   while (1)
      if (ptr->pt1[0]<=qtr->next->pt1[0]) {
         ptr->next = qtr->next;
         qtr->next = ptr;
         return;
      }

      else
         qtr = qtr->next;
}


/* *************************************************************
   this procedure creates the main edge table
************************************************************* */
void polygon::add_edge_table(edgetype ***et, eye *parm, light *lparm, int maxy) {

   edgetype *ptr;                               // ptr to edge table
   int     *pointer = (int *)NULL;            // ptr to vertices
   int      mplace;                             // ptr to y
   int     i, j, k;                            // loop variables
   float    *top, *bottom;
   int      l;

   k = 0;
   for (i=0; i<ob->countobject; i++)
      if (ob->polynum[i] > k)
         k = ob->polynum[i];

   if (!k)
      return;

   pointer = new int[k+1];

   for (i=0; i<ob->countobject; i++)
      if (ob->polynum[i] > 0) {
         ptflag[i] = ((mcinfo & CITEXTURE) && tob->data[i] != (tex *)NULL);

         for (j=0; j<ob->polynum[i]; j++)
            pointer[j] = ob->edgeptr[i][j];

         pointer[ob->polynum[i]] = pointer[0];

         for (j=0; j<ob->polynum[i]; j++)
            if (round(ob->mvertex[pointer[j]][1]) !=
                round(ob->mvertex[pointer[j+1]][1])) {

               ptr = new edgetype;
               ptr->color = i;

               if (ob->mvertex[pointer[j]][1] < ob->mvertex[pointer[j+1]][1]) {
                  copyarray3(ptr->pt1, ob->mvertex[pointer[j]]);
                  copyarray3(ptr->colorstuff1, ob->gnormal[pointer[j]]);
                  copyarray3(ptr->pt2, ob->mvertex[pointer[j+1]]);
                  copyarray3(ptr->delta, ob->gnormal[pointer[j+1]]);
               }

               else {
                  copyarray3(ptr->pt2, ob->mvertex[pointer[j]]);
                  copyarray3(ptr->delta, ob->gnormal[pointer[j]]);
                  copyarray3(ptr->pt1, ob->mvertex[pointer[j+1]]);
                  copyarray3(ptr->colorstuff1, ob->gnormal[pointer[j+1]]);
               }

               mplace = prepare_edge(i, ptr, parm, lparm);
               k = mplace % MAXSUBPROC;
               ptr->next = et[k][mplace];
               et[k][mplace] = ptr;
            }

            else
               if (mctype < CONSTANT && mctype > SHADOW &&
                   round(ob->mvertex[pointer[j]][0]) !=
                   round(ob->mvertex[pointer[j+1]][0])) { // handles horizontal lines

                  ptr = new edgetype;
//                  ptr->color  = i;

                  if (ob->mvertex[pointer[j]][0] < ob->mvertex[pointer[j+1]][0]) {
                     bottom   = ob->mvertex[pointer[j]];
                     top      = ob->mvertex[pointer[j+1]];
                  }

                  else {
                     bottom   = ob->mvertex[pointer[j+1]];
                     top      = ob->mvertex[pointer[j]];
                  }

                  copyarray3(ptr->pt1, bottom);
                  ptr->pt2[0] = top[0];
                  ptr->deltax = ptr->pt2[0] - ptr->pt1[0];
                  ptr->deltaz = (top[2]-bottom[2]) / ptr->deltax;

                  l = round(ob->mvertex[pointer[j]][1]) % MAXSUBPROC;
                  ptr->next = et[l][maxy];
                  et[l][maxy] = ptr;
               }

      }

   delete pointer;
}


/* *************************************************************
   this procedure creates the main edge table
************************************************************* */
void polygon::add_edge_table(edgetype ***et, edgetype *ptr, int i, eye *parm, light *lparm, int maxy) {

   int      mplace;                             // ptr to y
   int      k;
   vector3f temp;

   if (round(ptr->pt1[1]) != round(ptr->pt2[1])) {
      mplace = prepare_edge(i, ptr, parm, lparm);
      k = mplace % MAXSUBPROC;
      ptr->next = et[k][mplace];
      et[k][mplace] = ptr;
   }

   else
      if (mctype > SHADOW && mctype < CONSTANT && round(ptr->pt1[0]) != round(ptr->pt2[0])) { // handles horizontal lines
         if (ptr->pt1[0] > ptr->pt2[0]) {
            copyarray3(temp, ptr->pt1);
            copyarray3(ptr->pt1, ptr->pt2);
            copyarray3(ptr->pt2, temp);
         }

         ptr->deltax = ptr->pt2[0] - ptr->pt1[0];
         ptr->deltaz = (ptr->pt2[2]-ptr->pt1[2]) / ptr->deltax;

         k = round(ptr->pt1[1]) % MAXSUBPROC;
         ptr->next = et[k][maxy];
         et[k][maxy] = ptr;
      }

}


/* *************************************************************
************************************************************* */
edgetype *polygon::edgelist(int i) {

   int j, k, l;
   edgetype ptr;
   edgetype *qtr;

   ptflag[i] = ((mcinfo & CITEXTURE) && tob->data[i] != (tex *)NULL);

   qtr = &ptr;

   k = ob->polynum[i]-1;
   for (j=0, l=1; j<k; j++, l++) {
      qtr->next = new edgetype;
      qtr = qtr->next;
      qtr->color = i;
      copyarray3(qtr->pt1, ob->mvertex[ob->edgeptr[i][j]]);
      copyarray3(qtr->pt2, ob->mvertex[ob->edgeptr[i][l]]);
      copyarray3(qtr->colorstuff1, ob->gnormal[ob->edgeptr[i][j]]);
      copyarray3(qtr->delta, ob->gnormal[ob->edgeptr[i][l]]);
   }

   qtr->next = new edgetype;
   qtr = qtr->next;
   qtr->color = i;
   copyarray3(qtr->pt1, ob->mvertex[ob->edgeptr[i][k]]);
   copyarray3(qtr->pt2, ob->mvertex[ob->edgeptr[i][0]]);
   copyarray3(qtr->colorstuff1, ob->gnormal[ob->edgeptr[i][k]]);
   copyarray3(qtr->delta, ob->gnormal[ob->edgeptr[i][0]]);

   qtr->next = (edgetype *)NULL;

   return ptr.next;
}


/* *************************************************************
************************************************************* */
void polygon::maptexture(edgetype **ptr, int i) {

   int     j, k;
   edgetype *qtr[4];

   if (tob->data[i]->mapfunc == MORPH) {
      for (j=0, qtr[0]=*ptr; j<tob->data[i]->vertex[0]; j++, qtr[0]=qtr[0]->next);

      tob->data[i]->morph_2D_to_polygon(ptr, qtr[0]);
   }

   else
      if (tob->data[i]->mapfunc == COORD) {
         for (j=0, k=1, qtr[0]=*ptr; j<ob->polynum[i]; j=k, k++, qtr[0]=qtr[0]->next) {
            copyarray2(qtr[0]->t[0], tob->data[i]->pt[j]);
            copyarray2(qtr[0]->t[1], tob->data[i]->pt[k]);
         }

      }

      else {                                    // corner
         j = k = 0;
         qtr[0] = *ptr;

         while (k<4)
            if (j == tob->data[i]->vertex[k]) {
               if (k<3)
                  qtr[k+1] = qtr[k];
               k++;
            }

            else {
               j++;
               qtr[k] = qtr[k]->next;
            }

         tob->data[i]->map_2D_to_polygon(ptr, qtr);
      }

}


/* *************************************************************
   this function is the main clipping routine
************************************************************* */
int polygon::polyclet(edgetype ***et, eye *parm, light *lparm, int maxx, int maxy) {

   float        extreme[2][4];
   int         i, j, k;
   edgetype     ptr;
   edgetype     *qtr, *pptr;
   float	polyarea, texarea;
   float	pscale;
   vector3f	temp;

   if (-bbox[0][0]/bbox[0][2] > parm->vrc[1] ||     // outside boundaries
       -bbox[1][0]/bbox[0][2] < parm->vrc[0] ||
       -bbox[0][1]/bbox[0][2] > parm->vrc[3] ||
       -bbox[1][1]/bbox[0][2] < parm->vrc[2]) {
      ob->countobject = 0;

      return 0;
   }

   if (ptflag != (char *)NULL)
      delete ptflag;
   ptflag = new char[ob->countobject];
   pscale = SQR(parm->query_scale());

   if ((mcinfo & CITEXTURE)) {
      if (area != (float *)NULL)
         delete area;
      area = new float[ob->countobject];
   }

   if (mctype == CONSTANT) {
      if (colortable != (vector3f *)NULL)
         delete colortable;

      colortable = new vector3f[ob->countobject];
      bzero(colortable, 3*ob->countobject<<2);
   }

   if (bbox[1][2] <= front &&
       -bbox[0][0]/bbox[1][2] > parm->vrc[0] &&     // inside boundaries
       -bbox[1][0]/bbox[1][2] < parm->vrc[1] &&
       -bbox[0][1]/bbox[1][2] > parm->vrc[2] &&
       -bbox[1][1]/bbox[1][2] < parm->vrc[3]) {

      if (mctype == CONSTANT)
         constcolor(parm, lparm);

      if (!(mcinfo & CITEXTURE)) {
         for (i=0; i<ob->countvertex; i++)
            parm->map2screen(ob->mvertex[i]);     // map to screen

         add_edge_table(et, parm, lparm, maxy);
      }

      else
         for (i=0; i<ob->countobject; i++) {
            if (ob->polynum[i]) {
               ptr.next = edgelist(i);

               if (ptflag[i]) {
                  maptexture(&ptr.next, i);

                  polyarea = texarea = 0;
                  for (qtr=ptr.next; qtr != (edgetype *)NULL; qtr=qtr->next) {
                     xproduct(temp, qtr->pt1, qtr->pt2);
                     polyarea += dotproduct3(ob->normal[i], temp);
                     texarea  += xproduct2(qtr->t[0], qtr->t[1]);
                  }

                  area[i] = sqrt(abs(texarea/(polyarea*pscale)));
               }

               parm->map2screen(ptr.next->pt1);

               for (qtr=ptr.next; qtr!=(edgetype *)NULL; qtr=ptr.next) {
                  parm->map2screen(qtr->pt2);

                  if (qtr->next != (edgetype *)NULL)
                     copyarray3(qtr->next->pt1, qtr->pt2);

                  ptr.next = qtr->next;

                  if (qtr->pt1[1] > qtr->pt2[1]) {
                     pptr = new edgetype;
                     pptr->color = i;

                     copyarray3(pptr->pt1, qtr->pt2);
                     copyarray3(pptr->colorstuff1, qtr->delta);
                     copyarray2(pptr->t[0], qtr->t[1]);

                     copyarray3(pptr->pt2, qtr->pt1);
                     copyarray3(pptr->delta, qtr->colorstuff1);
                     copyarray2(pptr->t[1], qtr->t[0]);

                     delete qtr;
                     qtr = pptr;
                  }

                  add_edge_table(et, qtr, i, parm, lparm, maxy);
               }

            }

      }

      return 1;
   }

   for (i=0; i<ob->countobject; i++)
      if (ob->polynum[i]) {
         copyarray3(extreme[0], ob->mvertex[ob->edgeptr[i][0]]);   // bound polygon box
         copyarray3(extreme[1], ob->mvertex[ob->edgeptr[i][0]]);   // bound polygon box

         for (j=1; j<ob->polynum[i]; j++) {
            for (k=0; k<3; k++)
               if (extreme[0][k] > ob->mvertex[ob->edgeptr[i][j]][k])
                  extreme[0][k] = ob->mvertex[ob->edgeptr[i][j]][k];
               else
                  if (extreme[1][k] < ob->mvertex[ob->edgeptr[i][j]][k])
                     extreme[1][k] = ob->mvertex[ob->edgeptr[i][j]][k];
         }

         if (extreme[0][2] > front ||                   // outside boundaries
             -extreme[0][0]/extreme[0][2] > parm->vrc[1] ||
             -extreme[1][0]/extreme[0][2] < parm->vrc[0] ||
             -extreme[0][1]/extreme[0][2] > parm->vrc[3] ||
             -extreme[1][1]/extreme[0][2] < parm->vrc[2])
            ob->polynum[i] = 0;

         else { // This part basicly clips verticies and creates edge table
            ptr.next = edgelist(i);

            if (ptflag[i]) {
               maptexture(&ptr.next, i);

               polyarea = texarea = 0;
               for (qtr=ptr.next; qtr != (edgetype *)NULL; qtr=qtr->next) {
                  xproduct(temp, qtr->pt1, qtr->pt2);
                  polyarea += dotproduct3(ob->normal[i], temp);
                  texarea  += xproduct2(qtr->t[0], qtr->t[1]);
               }

               area[i] = sqrt(abs(texarea/(polyarea*pscale)));
            }

            if (extreme[1][2] > front) {
               clip_greater(&ptr, Z, front, ob->normal[i], parm);
               post_clip(&ptr);
               extreme[1][2] = front;
            }

            if (ptr.next != (edgetype *)NULL) {

               if (mctype == CONSTANT)
                  constcolor(parm, lparm, i, ptr.next);

               parm->map2screen(ptr.next->pt1);

               copyarray2(extreme[0], ptr.next->pt1);
               copyarray2(extreme[1], ptr.next->pt1);

               for (qtr=ptr.next; qtr!=(edgetype *)NULL; qtr=qtr->next) { // map to screen
                  parm->map2screen(qtr->pt2);

                  if (qtr->next != (edgetype *)NULL)
                     copyarray3(qtr->next->pt1, qtr->pt2);

                  for (k=0; k<2; k++)
                     if (extreme[0][k] > qtr->pt2[k])
                        extreme[0][k] = qtr->pt2[k];
                     else
                        if (extreme[1][k] < qtr->pt2[k])
                           extreme[1][k] = qtr->pt2[k];
               }

               if (extreme[0][0] < 0.0) {
                  clip_lesser(&ptr, X, 0.0, ob->normal[i], parm);
                  post_clip(&ptr);
               }

               if (extreme[1][0] >= maxx) {
                  clip_greater(&ptr, X, (float )(maxx-1), ob->normal[i], parm);
                  post_clip(&ptr);
               }

               if (extreme[0][1] < 0.0) {
                  clip_lesser(&ptr, Y, 0.0, ob->normal[i], parm);
                  post_clip(&ptr);
               }

               if (extreme[1][1] >= maxy) {
                  clip_greater(&ptr, Y, (float )(maxy-1), ob->normal[i], parm);
                  post_clip(&ptr);
               }

               for (qtr=ptr.next; qtr!=(edgetype *)NULL; qtr=ptr.next) {
                  ptr.next = qtr->next;

                  if (qtr->pt1[1] > qtr->pt2[1]) {
                     pptr = new edgetype;
                     pptr->color = i;

                     copyarray3(pptr->pt1, qtr->pt2);
                     copyarray3(pptr->colorstuff1, qtr->delta);
                     copyarray2(pptr->t[0], qtr->t[1]);

                     copyarray3(pptr->pt2, qtr->pt1);
                     copyarray3(pptr->delta, qtr->colorstuff1);
                     copyarray2(pptr->t[1], qtr->t[0]);

                     delete qtr;
                     qtr = pptr;
                  }

                  add_edge_table(et, qtr, i, parm, lparm, maxy);
               }

            }

         }

      }

   return 1;
}


/* *************************************************************
   this function is the main clipping routine
************************************************************* */
int polygon::beamclet(edgetype ***et, light *lparm, int maxx, int maxy) {

   float	extreme[2][4];
   int		i, j, k;
   edgetype	ptr;
   edgetype	*qtr, *pptr;

   if ((lparm->ltype == BEAM_POINT &&
        (-bbox[0][0]/bbox[0][2] > lparm->vrc[1] ||     // outside boundaries
         -bbox[1][0]/bbox[0][2] < lparm->vrc[0] ||
         -bbox[0][1]/bbox[0][2] > lparm->vrc[3] ||
         -bbox[1][1]/bbox[0][2] < lparm->vrc[2])) ||
       (lparm->ltype == BEAM_FAR &&
        (bbox[0][0] > lparm->vrc[1] ||     // outside boundaries
         bbox[1][0] < lparm->vrc[0] ||
         bbox[0][1] > lparm->vrc[3] ||
         bbox[1][1] < lparm->vrc[2]))) {
       ob->countobject = 0;

       return 0;
   }

   ptflag = new char[ob->countobject];
   area = new float[ob->countobject];

   if (bbox[1][2] <= front) {
      if ((lparm->ltype == BEAM_POINT &&
           -bbox[0][0]/bbox[1][2] > lparm->vrc[0] &&     // inside boundaries
           -bbox[1][0]/bbox[1][2] < lparm->vrc[1] &&
           -bbox[0][1]/bbox[1][2] > lparm->vrc[2] &&
           -bbox[1][1]/bbox[1][2] < lparm->vrc[3]) ||
          (lparm->ltype == BEAM_FAR &&
           bbox[0][0] > lparm->vrc[0] &&     // inside boundaries
           bbox[1][0] < lparm->vrc[1] &&
           bbox[0][1] > lparm->vrc[2] &&
           bbox[1][1] < lparm->vrc[3])) {

         for (i=0; i<ob->countvertex; i++)
            lparm->map2screen(ob->mvertex[i]);     // map to screen

         add_edge_table(et, lparm, lparm, maxy);

         return 1;
      }

   }

   for (i=0; i<ob->countobject; i++)
      if (ob->polynum[i]) {
         copyarray3(extreme[0], ob->mvertex[ob->edgeptr[i][0]]);   // bound polygon box
         copyarray3(extreme[1], extreme[0]);   // bound polygon box

         for (j=1; j<ob->polynum[i]; j++) {
            for (k=0; k<3; k++)
               if (extreme[0][k] > ob->mvertex[ob->edgeptr[i][j]][k])
                  extreme[0][k] = ob->mvertex[ob->edgeptr[i][j]][k];
               else
                  if (extreme[1][k] < ob->mvertex[ob->edgeptr[i][j]][k])
                     extreme[1][k] = ob->mvertex[ob->edgeptr[i][j]][k];
         }

         if (extreme[0][2] > front ||            // outside boundaries
             ((lparm->ltype == BEAM_POINT &&
               (-extreme[0][0]/extreme[0][2] > lparm->vrc[1] ||
                -extreme[1][0]/extreme[0][2] < lparm->vrc[0] ||
                -extreme[0][1]/extreme[0][2] > lparm->vrc[3] ||
                -extreme[1][1]/extreme[0][2] < lparm->vrc[2])) ||
               (lparm->ltype == BEAM_FAR &&
                (extreme[0][0] > lparm->vrc[1] ||
                 extreme[1][0] < lparm->vrc[0] ||
                 extreme[0][1] > lparm->vrc[3] ||
                 extreme[1][1] < lparm->vrc[2]))))
            ob->polynum[i] = 0;

         else { // This part basicly clips verticies and creates edge table
            ptr.next = edgelist(i);

            if (extreme[1][2] > front) {
               if (lparm->ltype == BEAM_POINT)
                  clip_greater(&ptr, Z, front, ob->normal[i], lparm);
               else
                  bfclip_greater(&ptr, Z, front, ob->normal[i], lparm);

               post_clip(&ptr);
               extreme[1][2] = front;
            }

            if (ptr.next != (edgetype *)NULL) {

               if (lparm->ltype == BEAM_POINT)
                  lparm->map2screen(ptr.next->pt1);
               else
                  lparm->paramap2screen(ptr.next->pt1);

               copyarray2(extreme[0], ptr.next->pt1);
               copyarray2(extreme[1], ptr.next->pt1);

               if (lparm->ltype == BEAM_POINT)
                  lparm->map2screen(ptr.next->pt2);
               else
                  lparm->paramap2screen(ptr.next->pt2);

               if (ptr.next->next != (edgetype *)NULL)
                  copyarray3(ptr.next->next->pt1, ptr.next->pt2);

               for (qtr=ptr.next->next; qtr!=(edgetype *)NULL; qtr=qtr->next) { // map to screen
                  if (lparm->ltype == BEAM_POINT)
                     lparm->map2screen(qtr->pt2);
                  else
                     lparm->paramap2screen(qtr->pt2);

                  if (qtr->next != (edgetype *)NULL)
                     copyarray3(qtr->next->pt1, qtr->pt2);

                  for (k=0; k<2; k++)
                     if (extreme[0][k] > qtr->pt1[k])
                        extreme[0][k] = qtr->pt1[k];
                     else
                        if (extreme[1][k] < qtr->pt1[k])
                           extreme[1][k] = qtr->pt1[k];
               }

               if (extreme[0][0] < 0.0) {
                  if (lparm->ltype == BEAM_POINT)
                     clip_lesser(&ptr, X, 0.0, ob->normal[i], lparm);
                  else
                     bfclip_lesser(&ptr, X, 0.0, ob->normal[i], lparm);

                  post_clip(&ptr);
               }

               if (extreme[1][0] >= maxx) {
                  if (lparm->ltype == BEAM_POINT)
                     clip_greater(&ptr, X, (float )(maxx-1), ob->normal[i], lparm);
                  else
                     bfclip_greater(&ptr, X, (float )(maxx-1), ob->normal[i], lparm);

                  post_clip(&ptr);
               }

               if (extreme[0][1] < 0.0) {
                  if (lparm->ltype == BEAM_POINT)
                     clip_lesser(&ptr, Y, 0.0, ob->normal[i], lparm);
                  else
                     bfclip_lesser(&ptr, Y, 0.0, ob->normal[i], lparm);

                  post_clip(&ptr);
               }

               if (extreme[1][1] >= maxy) {
                  if (lparm->ltype == BEAM_POINT)
                     clip_greater(&ptr, Y, (float )(maxy-1), ob->normal[i], lparm);
                  else
                     bfclip_greater(&ptr, Y, (float )(maxy-1), ob->normal[i], lparm);

                  post_clip(&ptr);
               }

               for (qtr=ptr.next; qtr!=(edgetype *)NULL; qtr=ptr.next) {
                  ptr.next = qtr->next;

                  if (qtr->pt1[1] > qtr->pt2[1]) {
                     pptr = new edgetype;
                     pptr->color = i;

                     copyarray3(pptr->pt1, qtr->pt2);
                     copyarray3(pptr->colorstuff1, qtr->delta);

                     copyarray3(pptr->pt2, qtr->pt1);
                     copyarray3(pptr->delta, qtr->colorstuff1);

                     delete qtr;
                     qtr = pptr;
                  }

                  add_edge_table(et, qtr, i, lparm, lparm, maxy);
               }

            }

         }

      }

   return 1;
}

