
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */





#if !defined __RADIANT_H
#define __RADIANT_H

#include "base.h"

/* *************************************************************
************************************************************* */
class radiant : public pc {

   protected:
      float radius, inner_circle;
      float wcenter[4], wradius, winner_circle, wratio, tradius, sqrwradius;
      int   row[2], col[2];
      float scale;

      int   bound_box(eye *parm);
      float radiance(float pt[]);
      void  transform(eye *parm);

      int rad_clip(eye *parm, int maxx, int maxy);

   public:
      int   flagh;

      radiant() {
         inner_circle = 1;
         radius = 2;
         mcinfo = CITRANSPARENT;

         flagh = 0;
      }

      rendertype query_whatami() { return RADIANT; }

      void datacopy();

      void scan(camera *cparm, light *lparm, zbuffer *zbuff, subslave grandchild[], pc **shadptr);
      void scan(camera *cparm, light *lparm, subslave grandchild[], pc **shadptr);

      void beamscan(light *lparm, subslave grandchild[]);

      int parse(FILE *infile, char *token);
      void preprocess(listtype *mainlist, shader *sparm);

      int read_data(char filename[], datatype **dptr);

      int read_tex(char *filename, char *dfilename, texbase **tptr, texpolygon **tpptr);
      int read_3dtex(char *filename, char *dfilename, shader *sptr, shaderlisttype **slptr);
      int read_data(FILE *infile);

      void colorize(grandchildtype *child);
};

typedef radiant * radiantptrtype;

#endif
