
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */



#include "sbfast.h"



void sbfast::sbfastpg_llurh(eye *parm, light *lparm, zbuffer *zbuff, int inc, float dy) {

   int  h, i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;
   float row;
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;

                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   for ((!inc) ? h=MAXSUBPROC : h=inc; h<WINY; h+=MAXSUBPROC) {

      start_flag[inc] = 1;
      row = h;

      if (!SILENT)
         printf("y %d\n", h);

      for (j=0; j<WINX && (i=(int)row)<WINY; j++, row += dy) {
#include "sbshade.c"
      }

      for (; j<WINX && (i=(int)row)<WINY; j++, row += dy)
         sbbuffer->pdata[i][j] = 0;
   }

}


void sbfast::sbfastpg_llurv(eye *parm, light *lparm, zbuffer *zbuff, int inc, float dx) {

   int  h, i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;

   float col;
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;

                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   for (h=inc; h<WINX; h+=MAXSUBPROC) {

      start_flag[inc] = 1;
      col = h;

      if (!SILENT)
         printf("x %d\n", h);

      for (i=0; i<WINY && (j=(int)col)<WINX; i++, col += dx) {
#include "sbshade.c"
      }

      for (; i<WINY && (j=(int)col)<WINX; i++, col += dx)
         sbbuffer->pdata[i][j] = 0;
   }

}


void sbfast::sbfastpg_lrulh(eye *parm, light *lparm, zbuffer *zbuff, int inc, float dy) {

   int  h, i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;

   float row;
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;

                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   for ((!inc) ? h=MAXSUBPROC : h=inc; h<WINY; h+=MAXSUBPROC) {

      start_flag[inc] = 1;
      row = h;

      if (!SILENT)
         printf("y %d\n", h);

      for (j=WINX-1; j>-1 && (i=(int)row)<WINY; j--, row -= dy) {  // dy is negative - go up
#include "sbshade.c"
      }

      for (; j>-1 && (i=(int)row)<WINY; j--, row -= dy)    // dy is negative - go up
         sbbuffer->pdata[i][j] = 0;
   }

}


void sbfast::sbfastpg_lrulv(eye *parm, light *lparm, zbuffer *zbuff, int inc, float dx) {

   int  h, i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;

   float col;
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;

                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   for (h=inc; h<WINX; h+=MAXSUBPROC) {

      start_flag[inc] = 1;
      col = h;

      if (!SILENT)
         printf("x %d\n", h);

      for (i=0; i<WINY && (j=(int)col)>-1; i++, col += dx) {  // dx is negative, go left
#include "sbshade.c"
      }

      for (; i<WINY && (j=(int)col)>-1; i++, col += dx)    // dx is negative, go left
         sbbuffer->pdata[i][j] = 0;
   }

}


void sbfast::sbfastpg_negh(eye *parm, light *lparm, zbuffer *zbuff, int inc, float dy, float *up, float *horizon) {

   int  g, h, i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;

   float intersect[2];
   float row;
   float column[3];
   float incup;
   float delta[2], curr[2];

   float yaxis[3];
   float xzero[3] = {1,0,0};

   float op[4];
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;


   yaxis[0] = 0;
   yaxis[1] = 1;
   yaxis[2] = 1.0-WINY;
                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   copyarray2(column, up);
   incup = -up[1]*MAXSUBPROC;

   if (inc)
      h = inc;
   else
      h = MAXSUBPROC;

   column[2] = -(up[0]*(WINX-1) + up[1]*h);

   line2d_line2d_intersect(column, horizon, curr);
   column[2] += incup;
   line2d_line2d_intersect(column, horizon, delta);
   subarray2(delta, curr);

   for (column[2] = -(up[0]*(WINX-1)+up[1]*h); h<WINY; h+=MAXSUBPROC, column[2]+=incup) {

      if (!SILENT)
         printf("y %d \n", h);

      start_flag[inc] = 1;

      copyarray2(intersect, curr);

      if (intersect[0] >= WINX-1) {
         intersect[0] = WINX-1;
         intersect[1] = h;
      }

      else {
         if (intersect[1] > WINY-1)
            line2d_line2d_intersect(column, yaxis, intersect);

         if (intersect[0] < 0)
            line2d_line2d_intersect(column, xzero, intersect);
      }

      g = j = (int)intersect[0];
      i = (int)(intersect[1] = h - (WINX-1-j)*dy);

      if (i > WINY-1) {
         j++;
         i = (int)(intersect[1] += dy);
      }

      do {
#include "sbshade.c"
      } while (0);

      copyarray4(op, old_pos[inc]);

      for (j++, row=intersect[1]+dy; j<WINX && (i=(int)row)>-1; j++, row+=dy) {
#include "sbshade.c"
      }

      for (; j<WINX && (i=(int)row)>-1; j++, row+=dy)
         sbbuffer->pdata[i][j] = 0;

      copyarray4(old_pos[inc], op);

      for (j=g-1, row=intersect[1]-dy; j>-1 && (i=(int)row)<WINY; j--, row -= dy) {
#include "sbshade.c"
      }

      for (; j>-1 && (i=(int)row)<WINY; j--, row -= dy)
         sbbuffer->pdata[i][j] = 0;

      addarray2(curr, delta);
   }

}


void sbfast::sbfastpg_negv(eye *parm, light *lparm, zbuffer *zbuff, int inc, float dx, float *up, float *horizon) {

   int  g, h, i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;

   float intersect[2];
   float col;
   float column[3];
   float incup;
   float delta[2], curr[2];

   float yaxis[3];
   float xzero[3] = {1,0,0};

   float op[4];
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;


   yaxis[0] = 0;
   yaxis[1] = 1;
   yaxis[2] = 1.0-WINY;
                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   copyarray2(column, up);
   incup = -up[0]*MAXSUBPROC;

   h = inc;

   column[2] = -h*up[0];

   line2d_line2d_intersect(column, horizon, curr);
   column[2] += incup;
   line2d_line2d_intersect(column, horizon, delta);
   subarray2(delta, curr);

   for (column[2]=h*up[0]; h<WINX; h+=MAXSUBPROC, column[2]+=incup) {
      if (!SILENT)
         printf("x %d\n", h);

      start_flag[inc] = 1;

      copyarray2(intersect, curr);

      if (intersect[1] <= 0) {
         intersect[0] = h;
         intersect[1] = 0;
      }

      else {
         if (intersect[1] > WINY-1)
            line2d_line2d_intersect(column, yaxis, intersect);

         if (intersect[0] < 0)
            line2d_line2d_intersect(column, xzero, intersect);
      }

      g = i = (int)intersect[1];
      j = (int)(intersect[0] = h + i*dx);

      if (j > WINX-1) {
         i++;
         j = (int)(intersect[0] += dx);
      }

      do {
#include "sbshade.c"
      } while (0);

      copyarray4(op, old_pos[inc]);

      for (i++, col=intersect[0]+dx; i<WINY && (j=(int)col)>-1; i++, col+=dx) {
#include "sbshade.c"
      }

      for (; i<WINY && (j=(int)col)>-1; i++, col+=dx)
         sbbuffer->pdata[i][j] = 0;

      copyarray4(old_pos[inc], op);

      for (i=g-1, col=intersect[0]-dx; i>-1 && (j=(int)col)<WINX; i--, col -= dx) {
#include "sbshade.c"
      }

      for (; i>-1 && (j=(int)col)<WINX; i--, col -= dx)
         sbbuffer->pdata[i][j] = 0;

      addarray2(curr, delta);
   }

}


void sbfast::sbfastpg_posh(eye *parm, light *lparm, zbuffer *zbuff, int inc, float dy, float *up, float *horizon) {

   int  g, h, i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;

   float intersect[2];
   float row;
   float column[3];
   float incup;
   float delta[2], curr[2];

   float yaxis[3];
   float xaxis[3];

   float op[4];
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;


   yaxis[0] = 0;
   yaxis[1] = 1;
   yaxis[2] = 1.0-WINY;

   xaxis[0] = 1;
   xaxis[1] = 0;
   xaxis[2] = 1.0-WINX;
                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   copyarray2(column, up);
   incup = -up[1]*MAXSUBPROC;

   if (inc)
      h = inc;
   else
      h = MAXSUBPROC;

   column[2] = -h*up[1];

   line2d_line2d_intersect(column, horizon, curr);
   column[2] += incup;
   line2d_line2d_intersect(column, horizon, delta);
   subarray2(delta, curr);

   for (column[2] = -h*up[1]; h<WINY; h+=MAXSUBPROC, column[2]+=incup) {
      if (!SILENT)
         printf("y %d \n", h);

      start_flag[inc] = 1;

      copyarray2(intersect, curr);

      if (intersect[0] <= 0) {
         intersect[0] = 0;
         intersect[1] = h;
      }

      else {
         if (intersect[1] > WINY-1)
            line2d_line2d_intersect(column, yaxis, intersect);

         if (intersect[0] > WINX-1)
            line2d_line2d_intersect(column, xaxis, intersect);
      }

      g = j = (int)intersect[0];
      i = (int)(intersect[1] = h+j*dy);

      do {
#include "sbshade.c"
      } while (0);

      copyarray4(op, old_pos[inc]);

      for (j++, row=intersect[1]+dy; j<WINX && (i=(int)row)<WINY; j++, row+=dy) {
#include "sbshade.c"
      }

      for (; j<WINX && (i=(int)row)<WINY; j++, row+=dy)
         sbbuffer->pdata[i][j] = 0;

      copyarray4(old_pos[inc], op);

      for (j=g-1, row=intersect[1]-dy; j>-1 && (i=(int)row)>-1; j--, row -= dy) {
#include "sbshade.c"
      }

      for (; j>-1 && (i=(int)row)>-1; j--, row -= dy)
         sbbuffer->pdata[i][j] = 0;

      addarray2(curr, delta);
   }

}


void sbfast::sbfastpg_posv(eye *parm, light *lparm, zbuffer *zbuff, int inc, float dx, float *up, float *horizon) {

   int  g, h, i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;

   float intersect[2];
   float col;
   float column[3];
   float incup;
   float delta[2], curr[2];

   float yaxis[3];
   float xaxis[3];

   float op[4];
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;


   yaxis[0] = 0;
   yaxis[1] = 1;
   yaxis[2] = 1.0-WINY;

   xaxis[0] = 1;
   xaxis[1] = 0;
   xaxis[2] = 1.0-WINX;
                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   copyarray2(column, up);
   incup = -up[0]*MAXSUBPROC;

   h = inc;

   column[2] = -h*up[0];

   line2d_line2d_intersect(column, horizon, curr);
   column[2] += incup;
   line2d_line2d_intersect(column, horizon, delta);
   subarray2(delta, curr);

   for (column[2] = h*up[0]; h<WINX; h+=MAXSUBPROC, column[2]+=incup) {
      if (!SILENT)
         printf("x %d\n", h);

      start_flag[inc] = 1;

      copyarray2(intersect, curr);

      if (intersect[1] <= 0) {
         intersect[0] = h;
         intersect[1] = 0;
      }

      else {
         if (intersect[1] > WINY-1)
            line2d_line2d_intersect(column, yaxis, intersect);

         if (intersect[0] > WINX-1)
            line2d_line2d_intersect(column, xaxis, intersect);
      }

      g = i = (int)intersect[1];
      j = (int)(intersect[0] = h + i*dx);

      do {
#include "sbshade.c"
      } while (0);

      copyarray4(op, old_pos[inc]);

      for (i++, col=intersect[0]+dx; i<WINY && (j=(int)col)<WINX; i++, col+=dx) {
#include "sbshade.c"
      }

      for (; i<WINY && (j=(int)col)<WINX; i++, col+=dx)
         sbbuffer->pdata[i][j] = 0;

      copyarray4(old_pos[inc], op);

      for (i=g-1, col=intersect[0]-dx; i>-1 && (j=(int)col)>-1; i--, col -= dx) {
#include "sbshade.c"
      }

      for (; i>-1 && (j=(int)col)>-1; i--, col -= dx)
         sbbuffer->pdata[i][j] = 0;

      addarray2(curr, delta);
   }

}


void sbfast::sbfastpg_horizontal(eye *parm, light *lparm, zbuffer *zbuff, int inc, int dflag) {

   int  i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;
   int up, down, vinc;
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;


   if (dflag) {
      up   = WINX;
      down = 0;
      vinc = 1;
   }

   else {
      up = -1;
      down = WINX-1;
      vinc = -1;
   }
                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   for (i=inc; i<WINY; i+=MAXSUBPROC) {

      start_flag[inc] = 1;

      if (!SILENT)
         printf("y %d\n", i);
      for (j=down; j != up; j+=vinc) {
#include "sbshade.c"
      }

      for (; j != up; j+=vinc)
         sbbuffer->pdata[i][j] = 0;
   }

}


void sbfast::sbfastpg_vertical(eye *parm, light *lparm, zbuffer *zbuff, int inc, int dflag) {

   int  i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;
   int up, down, vinc;
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;


   if (dflag) {
      up   = WINY;
      down = 0;
      vinc = 1;
   }

   else {
      up = -1;
//      down = (WINY-1) - ((WINY-1-inc) % MAXSUBPROC);
      down = WINY-1;
      vinc = -1;
   }
                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   for (j=inc; j<WINX; j+=MAXSUBPROC) {

      start_flag[inc] = 1;

      if (!SILENT)
         printf("x %d\n", j);
      for (i=down; i != up; i+=vinc) {
#include "sbshade.c"
      }

      for (; i != up; i+=vinc)
         sbbuffer->pdata[i][j] = 0;
   }

}


void sbfast::sbfastpg_horizontald(eye *parm, light *lparm, zbuffer *zbuff, int inc, int origin) {

   int  i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;
   float op[4];
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;


   if (origin < 0)              // shouldnt do this, but in case of fp error...
      origin = 0;
   else
      if (origin >= WINX)
         origin = WINX-1;
                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   for (i=inc; i<WINY; i+=MAXSUBPROC) {

      if (!SILENT)
         printf("y %d\n", i);

      start_flag[inc] = 1;

      j = origin;

      do {
#include "sbshade.c"
      } while(0);

      copyarray4(op, old_pos[inc]);

      for (j--; j > -1; j--) {
#include "sbshade.c"
      }

      for (; j > -1; j--)
         sbbuffer->pdata[i][j] = 0;

      copyarray4(old_pos[inc], op);

      for (j=origin+1; j<WINX; j++) {
#include "sbshade.c"
      }

      for (; j<WINX; j++)
         sbbuffer->pdata[i][j] = 0;
   }

}


void sbfast::sbfastpg_verticald(eye *parm, light *lparm, zbuffer *zbuff, int inc, int origin) {

   int  i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;
   float op[4];
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;


   if (origin < 0)              // shouldnt do this, but in case of fp error...
      origin = 0;
   else
      if (origin >= WINY)
         origin = WINY-1;
                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   for (j=inc; j<WINX; j+=MAXSUBPROC) {
      if (!SILENT)
         printf("x %d\n", j);

      start_flag[inc] = 1;

      i = origin;

      do {
#include "sbshade.c"
      } while (0);

      copyarray4(op, old_pos[inc]);

      for (i--; i > -1; i--) {
#include "sbshade.c"
      }

      for (; i > -1; i--)
         sbbuffer->pdata[i][j] = 0;

      copyarray4(old_pos[inc], op);

      for (i=origin+1; i<WINY; i++) {
#include "sbshade.c"
      }

      for (; i<WINY; i++)
         sbbuffer->pdata[i][j] = 0;
   }

}


void sbfast::sbfastpg_ullrh(eye *parm, light *lparm, zbuffer *zbuff, int inc, float dy) {

   int  h, i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;

   float row;
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;

                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   for ((!inc) ? h=MAXSUBPROC : h=inc; h<WINY; h+=MAXSUBPROC) {

      start_flag[inc] = 1;
      row = h;

      if (!SILENT)
         printf("y %d\n", h);

      for (j=0; j<WINX && (i=(int)row)>-1; j++, row += dy) {  // dy is negative - go down
#include "sbshade.c"
      }

      for (; j<WINX && (i=(int)row)>-1; j++, row += dy)    // dy is negative - go down
         sbbuffer->pdata[i][j] = 0;
   }

}


void sbfast::sbfastpg_ullrv(eye *parm, light *lparm, zbuffer *zbuff, int inc, float dx) {

   int  h, i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;

   float col;
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;

                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   for (h=inc; h<WINX; h+=MAXSUBPROC) {

      start_flag[inc] = 1;
      col = h;

      if (!SILENT)
         printf("x %d\n", h);

      for (i=WINY-1; i>-1 && (j=(int)col)<WINX; i--, col -= dx) {  // dx is negative, go right
#include "sbshade.c"
      }

      for (; i>-1 && (j=(int)col)<WINX; i--, col -= dx)    // dx is negative, go right
         sbbuffer->pdata[i][j] = 0;
   }

}


void sbfast::sbfastpg_urllh(eye *parm, light *lparm, zbuffer *zbuff, int inc, float dy) {

   int  h, i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;

   float row;
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;

                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   for ((!inc) ? h=MAXSUBPROC : h=inc; h<WINY; h+=MAXSUBPROC) {

      start_flag[inc] = 1;
      row = h;

      if (!SILENT)
         printf("y %d\n", h);

      for (j=WINX-1; j>-1 && (i=(int)row)>-1; j--, row -= dy) {
#include "sbshade.c"
      }

      for (; j>-1 && (i=(int)row)>-1; j--, row -= dy)
         sbbuffer->pdata[i][j] = 0;
   }

}


void sbfast::sbfastpg_urllv(eye *parm, light *lparm, zbuffer *zbuff, int inc, float dx) {

   int  h, i, j, k;
   vector4f surface, normal;
   float pzero[4], pray[4];
   float rcolor[3], acolor[3];
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;

   float col;
   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;

                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   for (h=inc; h < WINX; h+=MAXSUBPROC) {

      start_flag[inc] = 1;
      col = h;

      if (!SILENT)
         printf("x %d\n", h);

      for (i=WINY-1; i>-1 && (j=(int)col)>-1; i--, col -= dx) {
#include "sbshade.c"
      }

      for (; i>-1 && (j=(int)col)>-1; i--, col -= dx)
         sbbuffer->pdata[i][j] = 0;
   }

}


void sbfast::sbfastpg_postscan(eye *parm, light *lparm, zbuffer *zbuff, int inc) {

   int  i, j, k;
   vector4f surface, normal;
   vector4f pzero, pray;
   vector3f rcolor, acolor;
   light *lmain;
   int  flag3t = mcinfo & CI3DTEX;
   int  flag2t = mcinfo & CITEXTURE;
   int  flagt = flag3t | flag2t;
   int  flagl  = mcinfo & CILUM;
   int  flagtr = mcinfo & CITRANSPARENT;

   float increment;

   texcolortype texcolor;
   shaderparamtype sparam;

   vector4f isw[4];

   copymx4x4(isw, world);
   smultarray3(isw[0], isize);
   smultarray3(isw[1], isize);
   smultarray3(isw[2], isize);
   isw[0][3] = isw[1][3] = isw[2][3] = 0;

                                           // calculate the ray-creep increment
   increment = double((parm->vrc[1])*isize)/(double)WINX;

   for (lmain=lparm; lmain!=(light *)NULL && lmain->ltype != POINT && lmain->ltype != FAR; lmain=lmain->next);

   texcolor = *base_color;

   if (lmain != (light *)NULL && !flag3t)
      lmain->set_ambient(texcolor.color.ka, texcolor.ambient);

   pzero[0] = pzero[1] = pzero[2] = 0;
   pzero[3] = 1;
   matvecmulto(iworld, pzero);

   normal[3] = pray[3] = 0;
   surface[3] = 1;

   for (i=inc; i < WINY; i+=MAXSUBPROC)
      for (j=0; j < WINX; j++)
         while (sbbuffer->pdata[i][j]) {
            start_flag[inc] = 1;
#include "sbshade.c"
         }

}

