
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */





/* *************************************************************
************************************************************* */


#include "shadline.h"


/* *************************************************************
************************************************************* */
int shadline::point2plane(float *psplane, light *lparm) {

   float  vector[3];
   float  t;

   if (lparm->ltype == POINT) {
      vector[0] = wwai[0][0] - lparm->location[0];
      vector[1] = wwai[0][1] - lparm->location[1];
      vector[2] = wwai[0][2] - lparm->location[2];
   }

   else
      copyarray3(vector, lparm->location);

   line_plane_intersect(psplane, wwai[0], vector, &t);

   if (t <=0)
      return 0;

   wwai[0][0] += t*vector[0];
   wwai[0][1] += t*vector[1];
   wwai[0][2] += t*vector[2];

   if (lparm->ltype == POINT) {
      vector[0] = wwai[1][0] - lparm->location[0];
      vector[1] = wwai[1][1] - lparm->location[1];
      vector[2] = wwai[1][2] - lparm->location[2];
   }

   else
      copyarray3(vector, lparm->location);

   line_plane_intersect(psplane, wwai[1], vector, &t);

   if (t <=0)
      return 0;

   wwai[1][0] += t*vector[0];
   wwai[1][1] += t*vector[1];
   wwai[1][2] += t*vector[2];

   return 1;
}


/* *************************************************************
************************************************************* */
int shadline::datacopy2(line *pob, light *lparm) {

   copyarray4(wwai[0], pob->wwai[0]);

   sflag  = 0;
   mctype = pob->mctype;
   id = -pob->id;

   copyarray4(wwai[1], pob->wwai[1]);

   return point2plane(pob->splane, lparm);
}


/* **************************************************
************************************************** */
void shadline::colorize(grandchildtype *child) {

   int    i, j, k, l;
   int    scany;
   float  delta[2][2];
   float  pt[3];
   float  m;

   j = (wwai[0][1] < wwai[1][1]);
   i = !j;

   delta[1][1] = (wwai[j][1] - wwai[i][1]);
   m = delta[1][1] + 1;
   delta[0][0] = (wwai[j][0] - wwai[i][0])/m;
   delta[0][1] = (wwai[j][2] - wwai[i][2])/m;

   for (scany=round(wwai[i][1]); scany<=round(wwai[j][1]); scany++) {

      if (delta[0][0] > 0) {
         pt[0] = wwai[i][0];
         pt[1] = pt[0] + delta[0][0];
         pt[2] = wwai[i][2];
         delta[1][1] = delta[0][1]/(pt[1] - pt[0]);
      }

      else {
         pt[1] = wwai[i][0];
         pt[0] = pt[1] + delta[0][0];
         pt[2] = wwai[i][2] + delta[0][1];
         delta[1][1] = -delta[0][1]/(pt[1] - pt[0]);
      }

      k = round(pt[1]);

      for (l=round(pt[0]); l<=k; l++, pt[2] += delta[1][1])
         if (pt[2] > child->zbuff->zbuff[scany][l] || child->zbuff->zbuff[scany][l] > front) {
            child->zbuff->zbuff[scany][l]     = pt[2];
            child->zbuff->ybuff[scany][l][0] = child->zbuff->ybuff[scany][l][1] = child->zbuff->ybuff[scany][l][2] = 0;

            if (mctype == WFBW)
               child->zbuff->ambientbuff[scany][l][0] = child->zbuff->ambientbuff[scany][l][1] = child->zbuff->ambientbuff[scany][l][2] = 1.0;
         }

      wwai[i][0]   += delta[0][0];
      wwai[i][2]   += delta[0][1];
   }

   child->done = 1;
}
