
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */





/* *************************************************************
   This function scans poligonal objects into a zbuffer
************************************************************* */


#include "shadowpt.h"


/* *************************************************************
************************************************************* */
int shadowpt::point2plane(float psplane[], light *lparm) {

   float  vector[3];
   float  t;

   if (lparm->ltype == POINT) {
      vector[0] = wwai[0] - lparm->location[0];
      vector[1] = wwai[1] - lparm->location[1];
      vector[2] = wwai[2] - lparm->location[2];
   }

   else
      copyarray3(vector, lparm->location);

   line_plane_intersect(psplane, wwai, vector, &t);

   if (t <=0)
      return 0;

   wwai[0] += t*vector[0];
   wwai[1] += t*vector[1];
   wwai[2] += t*vector[2];

   return 1;
}


/* *************************************************************
   This procedure takes the basic object data, and creates a composite
   structure to be worked on.
************************************************************* */
int shadowpt::datacopy2(particle *pob, light *lparm) {

   copyarray4(wwai, pob->wwai);

   sflag  = 0;
   mctype = pob->mctype;
   id = -pob->id;

   return point2plane(pob->splane, lparm);
}


/* **************************************************
************************************************** */
void shadowpt::colorize(grandchildtype *child) {

   int    i, j;

   j = round(wwai[0]);
   i = round(wwai[1]);

   if (wwai[2] > child->zbuff->zbuff[i][j] || child->zbuff->zbuff[i][j] > front) {
      child->zbuff->zbuff[i][j] = wwai[2];
      child->zbuff->ybuff[i][j][0] = child->zbuff->ybuff[i][j][1] = child->zbuff->ybuff[i][j][2] = 0;

      if (mctype == WFBW)
        child->zbuff->ambientbuff[i][j][0] = child->zbuff->ambientbuff[i][j][1] = child->zbuff->ambientbuff[i][j][2] = 1.0; 
   }

   child->done = 1;
}
