
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */





/* *************************************************************
   This function scans poligonal objects into a zbuffer
************************************************************* */


#include "shadow.h"
#include <bstring.h>

/* *************************************************************
************************************************************* */
void shadow::object2plane(light *lparm) {

   int    i, j, k;
   int    flag;
   vector3f vector;
   float  t;
   char   *clip;
   int    xflag = 0;

   clip        = new char[ob->countvertex];

   if (lparm->ltype == FAR) {
      vector[0] = -lparm->transvec[0];
      vector[1] = -lparm->transvec[1];
      vector[2] = -lparm->transvec[2];

      for (i=0; i<ob->countvertex; i++) {
         flag = line_plane_intersect(splane, ob->mvertex[i], vector, &t);

         if (!(clip[i] = (t < 0 || !flag))) {
            ob->mvertex[i][0] += t*vector[0];
            ob->mvertex[i][1] += t*vector[1];
            ob->mvertex[i][2] += t*vector[2];
 
            if (xflag) {
               for (j=0; j<3; j++)
                  if (ob->mvertex[i][j] < bbox[0][j])
                     bbox[0][j] = ob->mvertex[i][j];
                  else
                     if (ob->mvertex[i][j] > bbox[1][j])
                        bbox[1][j] = ob->mvertex[i][j];
            }

            else {
               xflag = 1;
               copyarray4(bbox[0], ob->mvertex[i]);
               copyarray4(bbox[1], ob->mvertex[i]);
            }

         }

      }

   }

   else
      for (i=0; i<ob->countvertex; i++) {
/*
         vector[0] = ob->mvertex[i][0] - lparm->location[0];
         vector[1] = ob->mvertex[i][1] - lparm->location[1];
         vector[2] = ob->mvertex[i][2] - lparm->location[2];
*/
         vector[0] = ob->mvertex[i][0] - lparm->transloc[0];
         vector[1] = ob->mvertex[i][1] - lparm->transloc[1];
         vector[2] = ob->mvertex[i][2] - lparm->transloc[2];

         flag = line_plane_intersect(splane, ob->mvertex[i], vector, &t);

         if (!(clip[i] = (t < 0 || !flag))) {
            ob->mvertex[i][0] += t*vector[0];
            ob->mvertex[i][1] += t*vector[1];
            ob->mvertex[i][2] += t*vector[2];

            if (xflag) {
               for (j=0; j<3; j++)
                  if (ob->mvertex[i][j] < bbox[0][j])
                     bbox[0][j] = ob->mvertex[i][j];
                  else
                     if (ob->mvertex[i][j] > bbox[1][j])
                        bbox[1][j] = ob->mvertex[i][j];
            }

            else {
               xflag = 1;
               copyarray4(bbox[0], ob->mvertex[i]);
               copyarray4(bbox[1], ob->mvertex[i]);
            }

         }

      }

   for (i=0; i<ob->countobject; i++)
      if (ob->polynum[i])
         for (k=0; k<ob->polynum[i]; k++)
            if (clip[ob->edgeptr[i][k]]) {
               ob->polynum[i] = 0;
               break;
            }

   delete clip;
}


/* **************************************************
************************************************** */
void shadow::colorize(grandchildtype *child) {

   switch (mctype) {

      case SHADOW:
         shadct(child->cam, child->lit, child->zbuff, child->e, child->id);
         break;

      case BW:
         polybw(child->cam, child->zbuff, child->e, child->id);
         break;

      default:
         polywfbw(child->zbuff, child->e, child->id);
         break;
   }

   child->done = 1;
}


/* **************************************************
************************************************** */
void shadow::shadct(eye *parm, light *lparm, zbuffer *zbuff,
                    edgetype **et, int inc) {

   edgetype *aet;
   edgetype *ptr, *qtr;               // temp pointer
   int      scany;                 // current line being scanned
   int      i;                     // loop counter
   int      mtempx[2];
   float    mtempz;                // current x, z value for a pixel
   float    mdeltaz;               // delta z for a scan line
   float    surface[3];
   char      flagray = mcinfo & CIRAYCAST;
   char      nflagray = !flagray;
   char      bucketflag;
   bindex    *btr, *freelist;

   btr = freelist = (bindex *)NULL;

   for (scany=inc; scany<WINY && et[scany]==(edgetype *)NULL; scany+=MAXSUBPROC);

   if (scany < WINY) {
      for (ptr=et[scany]; ptr!=(edgetype *)NULL; ptr=et[scany]) {
         et[scany] = ptr->next;
         insert_edge(ptr, &btr, &freelist);
      }

      aet = (edgetype *)NULL;
      btr->build(&aet);
      btr->free_index(&freelist);
      btr = (bindex *)NULL;
   }

   while (scany < WINY) {               // scan all the lines

      surface[1] = scany;

      for (ptr=aet; ptr!=(edgetype *)NULL; ) {

         if (ptr->next != (edgetype *)NULL &&
             ptr->color == ptr->next->color) {

            qtr       = ptr->next;
            mtempx[0] = round(ptr->pt1[0]);
            mtempx[1] = round(qtr->pt1[0]);
            if (mtempx[0] != mtempx[1])
#include "shadct.c"

            ptr = qtr->next;
         }

         else {
            printf("%d SHIT ", scany);
            for (qtr=ptr; qtr!=(edgetype *)NULL; qtr=qtr->next)
               printf(" %f %d",qtr->pt2[1], qtr->color);

            printf("\n");
            ptr = ptr->next;
         }

      }

      scany += MAXSUBPROC;

      bucketflag = 0;

      qtr = aet;
      aet = (edgetype *)NULL;

      while (qtr != (edgetype *)NULL) {      // update aet
         ptr = qtr;
         qtr = qtr->next;

         if (scany >= round(ptr->pt2[1]))
            delete ptr;
         else {
            ptr->pt1[0] += ptr->dx;
            ptr->pt1[2] +=  ptr->dz;

            insert_edge(ptr, &btr, &freelist);
            bucketflag = 1;
         }

      }

      if (!bucketflag) {
         while (scany<WINY && et[scany]==(edgetype *)NULL)
            scany += MAXSUBPROC;

         if (scany < WINY) {
            for (ptr=et[scany]; ptr!=(edgetype *)NULL; ptr=et[scany]) {
               et[scany] = ptr->next;
               insert_edge(ptr, &btr, &freelist);
            }

            btr->build(&aet);
            btr->free_index(&freelist);
            btr = (bindex *)NULL;
         }

      }

      else
         if (scany < WINY) {
            for (ptr=et[scany]; ptr!=(edgetype *)NULL; ptr=et[scany]) {
               et[scany] = ptr->next;
               insert_edge(ptr, &btr, &freelist);
            }

            btr->build(&aet);
            btr->free_index(&freelist);
            btr = (bindex *)NULL;
         }

         else {
            btr->build(&aet);
            btr->free_index(&freelist);

            for (ptr=aet; ptr!=(edgetype *)NULL; aet=ptr->next, delete ptr, ptr=aet);
         }

   }

   delete freelist;
}


/* *************************************************************
   This procedure takes the basic object data, and creates a composite
   structure to be worked on.
************************************************************* */
int shadow::datacopy2(polygon *pob, camera *cparm, light *lparm, int invert) {

   float  T[4][4];
   int    i, j;                          // looping variables

   ob->countobject = pob->ob->countobject;
   ob->countvertex = pob->ob->countvertex;
   ob->countedge   = pob->ob->countedge;

   ob->mvertex = new vector4f[ob->countvertex];
   ob->polynum = new int[ob->countobject];
   ob->edgeptr = new pint[ob->countobject];
   ob->object  = new int[ob->countedge];
   ob->normal  = new vector4f[ob->countobject];
   ob->gnormal = new vector4f[ob->countvertex];

   bcopy(pob->ob->mvertex, ob->mvertex, ob->countvertex<<4);
   i = ob->countobject<<2;
   bcopy(pob->ob->polynum, ob->polynum, i);
   bcopy(pob->ob->object, ob->object, ob->countedge<<2);

   ob->edgeptr[0] = ob->object;
   for (i=1; i<ob->countobject; i++)
      ob->edgeptr[i] = ob->edgeptr[i-1] + ob->polynum[i-1];

   size = 1;
   init_mx(i, j, rotate);
   center[0] = center[1] = center[2] = 0;
   id = -pob->id;

   if (invert) {
      for (i=0; i<ob->countvertex; i++)
         matvecmulto(cparm->Tinverse, ob->mvertex[i]);
   }

   else {
      init_mx(i, j, T);

      for (i=0; i<3; i++)
         T[i][i] = pob->size;

      matmatmulto(pob->rotate, T);

      T[0][3] += pob->center[0];
      T[1][3] += pob->center[1];
      T[2][3] += pob->center[2];

      for (i=0; i<ob->countvertex; i++)
         matvecmulto(T, ob->mvertex[i]);
   }

   copyarray4(splane, pob->splane);

   sflag = 0;

   mcinfo = pob->mcinfo & CIRAYCAST;

   if (pob->mctype > BW) {
      mctype = SHADOW;
      bflag = pob->bflag;
   }

   else {
      mctype = pob->mctype;

      if (mctype <= WFBW)
         nflag = bflag = 0;
      else
         bflag = pob->bflag;
   }

   object2plane(lparm);

   return 1;
}
