
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */





#if !defined __SPATCH_H
#define __SPATCH_H


#define SPDELTA 5

#define vdownrow(x, maxcol) ( (x)+((maxcol)+2) )
#define vuprow(x, maxcol) ( (x)-((maxcol)+2) )
#define vtwo2one(row, col, maxcol) ( ((row)+1)*((maxcol)+2) + ((col)+1) )
#define pdownrow(x, maxcol) ( (x)+((maxcol)-1) )
#define ptwo2one(row, col, maxcol) ( (row)*((maxcol)-1) + (col) )


#include "polygon.h"

/* *************************************************************
************************************************************* */
class spatch : public make_poly {

   protected:
      spatchtype   *ob;                 // pointer to composite patch data
      datatype     *dob;                // pointer to patch data
      texpolygon   *tob;

      void transform(eye *parm);
      void convert(int i, int j, spatchtype *sob, texpolygon *stob, shaderlisttype *ssob);
      void spline2poly(spatchtype *sob, texpolygon *stob, int xflag);

      int  bound_box(eye *parm);

   public:

      rendertype query_whatami() { return SPATCH; }

      void begin_scan() {
         ob   = new spatchtype;
         tpob = (texpolygon *)NULL;
      }

      void end_scan() {

         if (ob != (spatchtype *)NULL)
            delete ob;

         if (tpob != (texpolygon *)NULL)
            delete tpob;
      }

      void datacopy();

      void colorize(grandchildtype *child);

      void beamscan(light *lparm, subslave grandchild[]);

      void scan(camera *cparm, light *lparm, zbuffer *zbuff, subslave grandchild[], pc **shadptr);
      void scan(camera *cparm, light *lparm, subslave grandchild[], pc **shadptr);

      int parse(FILE *infile, char *token);
      void preprocess(listtype *mainlist, shader *sparm);

      int read_data(char dataname[], datatype **dptr);
      int read_data(FILE *infile);
      int  read_tex(char *filename, char *dfilename, texbase **tptr, texpolygon **tpptr);
      int  read_3dtex(char *filename, char *dfilename, shader *sptr, shaderlisttype **slptr);
};

#endif
