
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */





#if !defined (__SPHERE_H)
#define __SPHERE_H

#include "geo.h"


/* *************************************************************
************************************************************* */
class sphere : public geo {

   friend class radiant;

   protected:
      float wscale[3];
      float normalcalc[4][4];

      float calc_area();

      void transform(eye *parm);

      void pg(eye *parm, light *lparm, zbuffer *zbuff, int inc);
      void lt(light *lparm, int inc);
      void geo2poly(texpolygon **ptob, shaderlisttype *slist);

   public:

      sphere() {
         wscale[0] = wscale[1] = wscale[2] = 1.0;
      }

      rendertype query_whatami() { return SPHERE; }

      int parse(FILE *infile, char *token);

      int read_data(FILE *infile) { 
         fscanf(infile, "%f %f %f", &wscale[0], &wscale[1], &wscale[2]);
         return 1;
      }

};

#endif
