
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */




#include "texpoly.h"


int tex::morph_2D_to_polygon(edgetype **header, edgetype *base) {

   double        texperim[4];
   double        polygonperim;
   edgetype      *ptr, *qtr;
   double        count, temp;
   int           i;
   dcounttype    *htr, *atr, *btr;
   double        lastcoord[2];
   double        delta[4][2];
   double        d[2];
   double        factor;

   if (*header != base) {
      for (ptr=*header, polygonperim=0; ptr->next!=(edgetype *)NULL; ptr=ptr->next)
         if (ptr->next == base)
            qtr = ptr;

      qtr->next = (edgetype *)NULL;
      ptr->next = *header;
      *header = base;
   }

   for (ptr=*header, polygonperim=0, htr=(dcounttype *)NULL; ptr!=(edgetype *)NULL; ptr=ptr->next) {

      if (htr == (dcounttype *)NULL) {
         htr = new dcounttype;
         atr = htr;
      }

      else {
         atr->next = new dcounttype;
         atr=atr->next;
      }

      atr->count = distance3(ptr->pt1, ptr->pt2);
      polygonperim += atr->count;
   }

   if (polygonperim < CORRECT)
      return 0;

   atr->next = (dcounttype *)NULL;

   delta[0][0] = coord[1][0] - coord[0][0];
   delta[0][1] = coord[1][1] - coord[0][1];
   texperim[0] = sqrt(SQR(delta[0][0]) + SQR(delta[0][1]));
   delta[1][0] = coord[2][0] - coord[1][0];
   delta[1][1] = coord[2][1] - coord[1][1];
   texperim[1] = sqrt(SQR(delta[1][0]) + SQR(delta[1][1]));
   delta[2][0] = coord[3][0] - coord[2][0];
   delta[2][1] = coord[3][1] - coord[2][1];
   texperim[2] = sqrt(SQR(delta[2][0]) + SQR(delta[2][1]));
   delta[3][0] = coord[0][0] - coord[3][0];
   delta[3][1] = coord[0][1] - coord[3][1];
   texperim[3] = sqrt(SQR(delta[3][0]) + SQR(delta[3][1]));

   factor = (texperim[0] + texperim[1] + texperim[2] + texperim[3])/polygonperim;

   for (atr=htr; atr!=(dcounttype *)NULL; atr=atr->next)
      atr->count *= factor;

   count  = 0;
   i      = 0;
   atr    = htr;
   ptr    = base;


   copyarray2(lastcoord, coord[0]);
   d[0] = delta[0][0]/texperim[0];
   d[1] = delta[0][1]/texperim[0];

   while (ptr != (edgetype *)NULL) {
      copyarray2(ptr->t[0], lastcoord);

      count += atr->count;

      if (count >= texperim[i]) {

         if (i == 3) {
            copyarray2(lastcoord, coord[0]);
         }

         else {
            qtr = new edgetype;

            copyarray3(qtr->pt2, ptr->pt2);
            copyarray3(qtr->delta, ptr->delta);
            qtr->next = ptr->next;
            ptr->next = qtr;

            btr = new dcounttype;
            btr->next = atr->next;
            atr->next = btr;

            btr->count = count - texperim[i];
            temp = btr->count/atr->count;

            ptr->pt2[0] = (ptr->pt1[0] - ptr->pt2[0])*temp + ptr->pt2[0];
            ptr->pt2[1] = (ptr->pt1[1] - ptr->pt2[1])*temp + ptr->pt2[1];
            ptr->pt2[2] = (ptr->pt1[2] - ptr->pt2[2])*temp + ptr->pt2[2];
            ptr->delta[0]  = (ptr->colorstuff1[0] - ptr->delta[0])*temp + ptr->delta[0];
            ptr->delta[1]  = (ptr->colorstuff1[1] - ptr->delta[1])*temp + ptr->delta[1];
            ptr->delta[2]  = (ptr->colorstuff1[2] - ptr->delta[2])*temp + ptr->delta[2];

            copyarray3(qtr->pt1, ptr->pt2);
            copyarray3(qtr->colorstuff1, ptr->delta);

            i++;

            count = 0;
            copyarray2(lastcoord, coord[i]);
            d[0] = delta[i][0]/texperim[i];
            d[1] = delta[i][1]/texperim[i];
         }

      }

      else {
         lastcoord[0] += (atr->count*d[0]);
         lastcoord[1] += (atr->count*d[1]);
      }

      copyarray2(ptr->t[1], lastcoord);

      ptr = ptr->next;
      atr = atr->next;
   }

   for (atr=htr; htr != (dcounttype *)NULL; atr=htr) {
      htr = htr->next;
      delete atr;
   }

   return 1;
}


int tex::map_2D_to_polygon(edgetype **header, edgetype *base[]) {

   edgetype    *ptr, *qtr;
   double      polygonperim;
   dcounttype  *htr, *atr;
   double      delta[4][2];
   double      lastcoord[2];
   int         i;
   double      d[2];

   if (*header != base[0]) {
      for (ptr=*header; ptr->next!=(edgetype *)NULL; ptr=ptr->next)
         if (ptr->next == base[0])
            qtr = ptr;

      qtr->next = (edgetype *)NULL;
      ptr->next = *header;
      *header = base[0];
   }

   delta[0][0] = coord[1][0] - coord[0][0];
   delta[0][1] = coord[1][1] - coord[0][1];

   delta[1][0] = coord[2][0] - coord[1][0];
   delta[1][1] = coord[2][1] - coord[1][1];

   delta[2][0] = coord[3][0] - coord[2][0];
   delta[2][1] = coord[3][1] - coord[2][1];

   delta[3][0] = coord[0][0] - coord[3][0];
   delta[3][1] = coord[0][1] - coord[3][1];

   for (i=0; i<4; i++)
      if (i==3 || base[i]!=base[i+1]) {
         for (ptr=base[i], polygonperim=0, htr=(dcounttype *)NULL; ptr != (edgetype *)NULL && (i==3 || ptr!=base[i+1]); ptr=ptr->next) {
            if (htr == (dcounttype *)NULL) {
               htr = new dcounttype;
               atr = htr;
            }

            else {
               atr->next = new dcounttype;
               atr=atr->next;
            }

            atr->count = distance3(ptr->pt1, ptr->pt2);
            polygonperim += atr->count;
         }

         atr->next = (dcounttype *)NULL;

         copyarray2(lastcoord, coord[i]);
         d[0] = delta[i][0]/polygonperim;
         d[1] = delta[i][1]/polygonperim;

         for (ptr=base[i], atr=htr; (i == 3 && ptr!=(edgetype *)NULL) || (i < 3 && ptr!=base[i+1]); ptr=ptr->next, atr=atr->next) {

            copyarray2(ptr->t[0], lastcoord);

            lastcoord[0] += (atr->count*d[0]);
            lastcoord[1] += (atr->count*d[1]);

            copyarray2(ptr->t[1], lastcoord);
         }

         for (atr=htr; htr!=(dcounttype *)NULL; atr=htr) {
            htr = htr->next;
            delete atr;
         }

      }

   return 1;
}


unsigned int tex::query_texel(float x, float y, shadetype *color, int frame, float d) {

   unsigned int xx, yy;
   float a, b;
   vector3f c;

   xx = ob->query_x() - 1;
   a = x - ((int)(x/xx))*xx;
   if (a < 0)
      a += xx;

   yy = ob->query_y() - 1;
   b = y - ((int)(y/yy))*yy;
   if (b < 0)
      b += yy;

   xx = ob->query_texel(a, b, c, frame, 1, d);

   multarray3(color->ka, c);
   multarray3(color->kp, c);
   multarray3(color->ks, c);
   multarray3(color->lum, c);

   return xx;
}
