
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */





#if !defined __TEXPOLY_H
#define __TEXPOLY_H

#include "global.h"
#include "texture.h"

typedef enum mapenum {
   MORPH  = 0,
   CORNER = 1,
   COORD  = 2,
   REPEAT = 3
} maptype;


typedef struct dcountstruct {

   double count;
   struct dcountstruct *next;
} dcounttype;

class tex {

   public:
      texbase   *ob;
      maptype   mapfunc;
      int       vertex[4];
      float     coord[4][2];
      vector2f  *pt;                     // for COORD

      int morph_2D_to_polygon(edgetype **header, edgetype *base);
      int map_2D_to_polygon(edgetype **header, edgetype *base[]);
      unsigned int query_texel(float x, float y, shadetype *color, int frame, float d);

      tex() {
         pt = (vector2f *)NULL;
      }

      ~tex() {
         if (pt != (vector2f *)NULL)
            delete pt;
      }

};


typedef tex * texptrtype;
typedef texptrtype * texpptrtype;


class texpolygon {

   public:
      char       filename[MAXSTRLEN], dataname[MAXSTRLEN];
      int       countobject;
      tex        **data;
      tex        ***pdata;

      texpolygon *next;

      texpolygon() {
         pdata = (tex ***)NULL;
         data  = (tex **)NULL;
      }

      ~texpolygon() {
         int i;

         if (data != (tex **)NULL) {
            for (i=0; i<countobject; i++)
               if (data[i] != (tex *)NULL)
                  delete data[i];
            delete data;
         }

         if (pdata != (tex ***)NULL)
            delete pdata;
      }

      void setup_data(int x) {
         data = new texptrtype[x];
      }

      void setup_pdata(int x) {
         pdata = new texpptrtype[x];
      }

};



#endif
