
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */




#include "texsbfast.h"


void sbmap::setup(vector4f *pt) {

   float size[2];

   if (ob == (texbase *)NULL)
      return;

   min[0] = max[0] = pt[0][0];

   if (pt[2][0] < min[0])
      min[0] = pt[2][0];
   else
      if (pt[2][0] > max[0])
         max[0] = pt[2][0];

   min[1] = max[1] = pt[0][1];

   if (pt[2][1] < min[1])
      min[1] = pt[2][1];
   else
      if (pt[2][1] > max[1])
         max[1] = pt[2][1];

   size[0] = max[0] - min[0];
   size[1] = max[1] - min[1];

   xscale = 1.0/size[0];
   yscale = 1.0/size[1];

   if ((flaginv = (abs(pt[0][0] - pt[3][0]) > CORRECT))) {
      xsign = pt[2][0] - pt[0][0];
      ysign = pt[2][1] - pt[0][1];
   }

   else {
      ysign = pt[2][0] - pt[0][0];
      xsign = pt[2][1] - pt[0][1];
   }

   area = sqrt((ob->query_x()*ob->query_y())/(size[0]*size[1]));
}


unsigned int sbmap::query_texel(float x, float y, shadetype *color, int frame, float d) {

   float a, b, e;
   vector3f c;
   unsigned int z;
   int xx, yy;

   if (mapfunc != REPEAT && (x < min[0] || x > max[0] || y < min[1] || y > max[1]))
      return 0;

   xx = ob->query_x() - 1;
   yy = ob->query_y() - 1;

   a = (x-min[0]) * xscale;
   a -= ((int)a);

   if (a < 0) 		// bug in sgi  (int)(-x) = roundup(x)
      a += 1.0;

   b = (y-min[1]) * yscale;
   b -= ((int)b);

   if (b < 0) 		// bug in sgi  (int)(-x) = roundup(x)
      b += 1.0;

   if (flaginv) {
      if (xsign < 0) 
         a = xx*(1 - a);
      else
         a = xx*a;

      if (ysign < 0) 
         b = yy*(1 - b);
      else
         b = yy*b;
   }

   else {
      if (xsign < 0)
         e = xx*(1 - b);
      else
         e = xx*b;

      if (ysign < 0)
         b = yy*(1 - a);
      else
         b = yy*a;

      a = e;
   }

   z = ob->query_texel(a, b, c, frame, 1, d*area);
   multarray3(color->ka, c);
   multarray3(color->kp, c);
   multarray3(color->ks, c);
   multarray3(color->lum, c);

   if (z > 0)
      return z;

   return 1;
}
