
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */





#if !defined __TEXSBFAST_H
#define __TEXSBFAST_H

#include "texpoly.h"

class sbmap {

   public:
      texbase  *ob;
      maptype  mapfunc;
      float    xscale, yscale;
      float    min[2], max[2];
      int      flaginv;
      float    xsign, ysign;
      float    area;
      void     setup(vector4f *pt);
      unsigned int query_texel(float x, float y, shadetype *color, int frame, float d);
};


class texsbfast {

   public:
      char       filename[MAXSTRLEN], dataname[MAXSTRLEN];
      int       countobject;
      sbmap      *data;

      texsbfast *next;

      texsbfast() {
         data  = (sbmap *)NULL;
      }

      ~texsbfast() {
         if (data != (sbmap *)NULL) 
            delete data;
      }

      void setup(int x) {

         if (data != (sbmap *)NULL)
            delete data;

         data = new sbmap[x];
      }

      int query_texel(float x, float y, shadetype *color, int frame, float d) {

         int i, j;

         for (i=j=0; i<countobject; i++)
            if (data[i].mapfunc == COORD) {
               if (data[i].query_texel(x,y,color, frame, d))
                  return 1;
            }

            else
               if (!j && data[i].query_texel(x,y,color, frame, d))
                  j = 1;

         return j;
      }

};


#endif
