
/* ************************************************************************
		Copyright (c) 1994-1996 Alex Harper
************************************************************************ */


#if !defined (__ZBUFFER_H)
#define __ZBUFFER_H

#include "matrix.h"
#include "texture.h"


/* *************************************************************
   this is the definition of the zbuffer class
************************************************************* */
class zbuffer : public rgb {

   protected:
      int read_filter(char *fname, mapf *filter);

   public:
      float         *zdata;
      float         **zbuff;          // z buffer
      vector3f      *adata;
      vector3f      **ambientbuff;
      vector3f      *ydata;
      vector3f      **ybuff;

                    zbuffer() { 
                       zdata = (float *)NULL;
                       zbuff = (float **)NULL;
                       adata = ydata = (vector3f *)NULL;
                       ambientbuff = ybuff = (vector3f **)NULL;
                    }

                    ~zbuffer() {
                       if (zdata != (float *)NULL) {
                          delete zdata;
                          delete adata;
                          delete ambientbuff;
                          delete ydata;
                          delete ybuff;
                       }

                    }

      int           initbuff(unsigned int x, unsigned int y);
      int           initbuff(unsigned int *d, puint *pd, unsigned int x, unsigned int y);
      int           get_buff(unsigned int **d, puint **pd, unsigned int *x, unsigned int *y);
      void          render(ALEXpixmap *mcanvas);
      void          render(ALEXimage mcanvas);
      void          render(mapul *mcanvas);
      void          antialias(char *fname, float gamma);
      void          save_buffer(FILE *outfile, int mapno);
      void          save_rgb(char *fname, int mapno);
      int           read_buffer(FILE *infile);
      void          catbuff(float gamma);
};

#endif
